# AWSS3

AWS S3 Interface for Julia

[![CI](https://github.com/JuliaCloud/AWSS3.jl/actions/workflows/CI.yaml/badge.svg?branch=master)](https://github.com/JuliaCloud/AWSS3.jl/actions/workflows/CI.yaml?query=branch%3Amaster)
[![Code Style: Blue](https://img.shields.io/badge/code%20style-blue-4495d1.svg)](https://github.com/invenia/BlueStyle)
[![ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://img.shields.io/badge/ColPrac-Contributor's%20Guide-blueviolet)](https://github.com/SciML/ColPrac)

**Installation**: at the Julia REPL, `using Pkg; Pkg.add("AWSS3")`

**Documentation**: [![][docs-stable-img]][docs-stable-url] [![][docs-latest-img]][docs-latest-url]

[docs-latest-img]: https://img.shields.io/badge/docs-latest-blue.svg
[docs-latest-url]: http://juliacloud.github.io/AWSS3.jl/dev/

[docs-stable-img]: https://img.shields.io/badge/docs-stable-blue.svg
[docs-stable-url]: http://juliacloud.github.io/AWSS3.jl/stable/

## Example
```julia
using AWSS3
using AWS # for `global_aws_config`

aws = global_aws_config(; region="us-east-2") # pass keyword arguments to change defaults

s3_create_bucket(aws, "my.bucket")

# if the config is omitted it will try to infer it as usual from AWS.jl
s3_delete_bucket("my.bucket")

p = S3Path("s3://my.bucket/test1.txt")  # provides an filesystem-like interface
write(p, "some data")

read(p, byte_range=1:4)  # returns b"some"

response = write(p, "other data"; returns=:response) # returns the raw `AWS.Response` on writing to S3
parsed_response = write(p, "other data"; returns=:parsed) # returns the parsed `AWS.Response` (default)
versioned_path = write(p, "other data"; returns=:path) # returns the `S3Path` written to S3, including the version ID
```

# Amazon states that version IDs are UTF-8 encoded, URL-ready, opaque strings no longer than
# 1024 bytes
# – https://docs.aws.amazon.com/AmazonS3/latest/userguide/versioning-workflows.html#version-ids
#
# In practise version IDs seems to be much narrower in scope:
# https://github.com/JuliaCloud/AWSS3.jl/pull/199#issuecomment-901995960
#
# An unversioned object can be accessed using the "null" version ID. For details see:
# https://github.com/JuliaCloud/AWSS3.jl/issues/241
const VERSION_ID_REGEX = r"^(?:[0-9a-zA-Z\._]{32}|null)$"

struct S3Path{A<:AbstractS3PathConfig} <: AbstractPath
    segments::Tuple{Vararg{String}}
    root::String
    drive::String
    isdirectory::Bool
    version::Union{String,Nothing}
    config::A

    # Inner constructor performs no data checking and is only meant for direct use by
    # deserialization.
    function S3Path{A}(
        segments, root, drive, isdirectory, version, config::A
    ) where {A<:AbstractS3PathConfig}
        return new(segments, root, drive, isdirectory, version, config)
    end
end

function S3Path(
    segments, root, drive, isdirectory, version::AbstractString, config::A
) where {A<:AbstractS3PathConfig}
    # Validate the `version` string provided is valid. Having this check during construction
    # allows us to fail early instead of having to wait to make an API call to fail.
    if !occursin(VERSION_ID_REGEX, version)
        throw(ArgumentError("`version` string is invalid: $(repr(version))"))
    end

    return S3Path{A}(segments, root, drive, isdirectory, version, config)
end

function S3Path(
    segments, root, drive, isdirectory, version::Nothing, config::A
) where {A<:AbstractS3PathConfig}
    return S3Path{A}(segments, root, drive, isdirectory, version, config)
end

"""
    S3Path()
    S3Path(str::AbstractString; version::$(AbstractS3Version)=nothing, config::$(AbstractS3PathConfig)=nothing)
    S3Path(path::S3Path; isdirectory=path.isdirectory, version=path.version, config=path.config)

Construct a new AWS S3 path type which should be of the form
`"s3://<bucket>/prefix/to/my/object"`.

NOTES:

- Directories are required to have a trailing `/` due to how S3
  distinguishes files from folders, as internally they're just
  keys to objects.
- Objects `p"s3://bucket/a"` and `p"s3://bucket/a/b"` can co-exist.
  If both of these objects exist listing the keys for `p"s3://bucket/a"` returns
  `[p"s3://bucket/a"]` while `p"s3://bucket/a/"` returns `[p"s3://bucket/a/b"]`.
- The drive property will return `"s3://<bucket>"`
- On top of the standard path properties (e.g., `segments`, `root`, `drive`,
  `separator`), `S3Path`s also support `bucket` and `key` properties for your
  convenience.
- If `version` argument is `nothing`, will return latest version of object. Version
  can be provided via either kwarg `version` or as suffix `"?versionId=<object_version>"`
  of `str`, e.g., `"s3://<bucket>/prefix/to/my/object?versionId=<object_version>"`.
- If `config` is left at its default value of `nothing`, then the
  latest `global_aws_config()` will be used in any operations involving the
  path. To "freeze" the config at construction time, explicitly pass an
  `AbstractAWSConfig` to the `config` keyword argument.
"""
S3Path() = S3Path((), "/", "", true, nothing, nothing)

# below definition needed by FilePathsBase
S3Path{A}() where {A<:AbstractS3PathConfig} = S3Path()

function S3Path(
    bucket::AbstractString,
    key::AbstractString;
    isdirectory::Bool=endswith(key, "/"),
    version::AbstractS3Version=nothing,
    config::AbstractS3PathConfig=nothing,
)
    return S3Path(
        Tuple(filter!(!isempty, split(key, "/"))),
        "/",
        strip(startswith(bucket, "s3://") ? bucket : "s3://$bucket", '/'),
        isdirectory,
        version,
        config,
    )
end

function S3Path(
    bucket::AbstractString,
    key::AbstractPath;
    isdirectory::Bool=false,
    version::AbstractS3Version=nothing,
    config::AbstractS3PathConfig=nothing,
)
    return S3Path(
        key.segments, "/", normalize_bucket_name(bucket), isdirectory, version, config
    )
end

function S3Path(
    path::S3Path; isdirectory=path.isdirectory, version=path.version, config=path.config
)
    return S3Path(path.bucket, path.key; isdirectory, config, version)
end

# To avoid a breaking change.
function S3Path(
    str::AbstractString;
    isdirectory::Union{Bool,Nothing}=nothing,
    version::AbstractS3Version=nothing,
    config::AbstractS3PathConfig=nothing,
)
    result = tryparse(S3Path, str; config)
    result !== nothing || throw(ArgumentError("Invalid s3 path string: $str"))
    ver = if version !== nothing
        if result.version !== nothing && result.version != version
            throw(ArgumentError("Conflicting object versions in `version` and `str`"))
        end
        version
    else
        result.version
    end

    # Replace the parsed isdirectory field with an explicit passed in argument.
    is_dir = isdirectory === nothing ? result.isdirectory : isdirectory

    # Warning: We need to use the full constructor because reconstructing with the bucket
    # and key results in inconsistent `root` fields.
    return S3Path(result.segments, result.root, result.drive, is_dir, ver, result.config)
end

# Parses a URI in the S3 scheme as an S3Path combining the conventions documented in:
# - https://docs.aws.amazon.com/AmazonS3/latest/userguide/access-bucket-intro.html#accessing-a-bucket-using-S3-format
# - https://docs.aws.amazon.com/AmazonS3/latest/userguide/RetMetaOfObjVersion.html
function Base.tryparse(
    ::Type{<:S3Path}, str::AbstractString; config::AbstractS3PathConfig=nothing
)
    uri = URI(str)
    uri.scheme == "s3" || return nothing

    drive = "s3://$(uri.host)"
    root = isempty(uri.path) ? "" : "/"
    isdirectory = isempty(uri.path) || endswith(uri.path, '/')
    path = Tuple(split(uri.path, '/'; keepempty=false))
    version = get(queryparams(uri), "versionId", nothing)

    return S3Path(path, root, drive, isdirectory, version, config)
end

function Base.parse(::Type{P}, p::P; kwargs...) where {P<:S3Path}
    return p
end

function normalize_bucket_name(bucket)
    return strip(startswith(bucket, "s3://") ? bucket : "s3://$bucket", '/')
end

function Base.print(io::IO, fp::S3Path)
    print(io, fp.anchor, fp.key)
    fp.version !== nothing && print(io, "?versionId=", fp.version)
    return nothing
end

function Base.:(==)(a::S3Path, b::S3Path)
    return (
        a.segments == b.segments &&
        a.root == b.root &&
        a.drive == b.drive &&
        a.isdirectory == b.isdirectory &&
        a.version == b.version
    )
end

function Base.getproperty(fp::S3Path, attr::Symbol)
    if attr === :anchor
        return fp.drive * fp.root
    elseif attr === :separator
        return "/"
    elseif attr === :bucket
        return split(fp.drive, "//")[2]
    elseif attr === :key
        if isempty(fp.segments)
            return ""
        end

        return join(fp.segments, '/') * (fp.isdirectory ? "/" : "")
    else
        return getfield(fp, attr)
    end
end

# We need to special case join and parents so that we propagate
# directories correctly (see type docstring for details)
function FilePathsBase.join(prefix::S3Path, pieces::AbstractString...)
    isempty(pieces) && return prefix

    segments = String[prefix.segments...]
    isdirectory = endswith(last(pieces), "/")

    for p in pieces
        append!(segments, filter!(!isempty, split(p, "/")))
    end

    return S3Path(
        tuple(segments...),
        "/",
        prefix.drive,
        isdirectory,
        nothing, # Version is per-object, so we should not propagate it from the prefix
        prefix.config,
    )
end

function FilePathsBase.parents(fp::S3Path)
    if hasparent(fp)
        return map(0:(length(fp.segments) - 1)) do i
            S3Path(fp.segments[1:i], fp.root, fp.drive, true, nothing, fp.config)
        end
    elseif fp.segments == tuple(".") || isempty(fp.segments)
        return [fp]
    else
        return [isempty(fp.root) ? Path(fp, tuple(".")) : Path(fp, ())]
    end
end

"""
    get_config(fp::S3Path)

Returns the AWS configuration used by the path `fp`.  This can be stored within the path itself, but if not
it will be fetched with `AWS.global_aws_config()`.
"""
get_config(fp::S3Path) = @something(fp.config, global_aws_config())

function FilePathsBase.exists(fp::S3Path)
    return s3_exists(get_config(fp), fp.bucket, fp.key; fp.version)
end

Base.isfile(fp::S3Path) = !fp.isdirectory && exists(fp)
function Base.isdir(fp::S3Path)
    fp.isdirectory || return false
    if isempty(fp.segments)  # special handling of buckets themselves
        try
            params = Dict("prefix" => "", "delimiter" => "/", "max-keys" => "0")
            @mock S3.list_objects_v2(fp.bucket, params; aws_config=get_config(fp))
            return true
        catch e
            if ecode(e) == "NoSuchBucket"
                return false
            else
                rethrow()
            end
        end
    else
        exists(fp)
    end
end

function FilePathsBase.walkpath(fp::S3Path; kwargs...)
    # Select objects with that prefix
    objects = s3_list_objects(get_config(fp), fp.bucket, fp.key; delimiter="")
    root = joinpath(fp, "/")

    # Construct a new Channel using a recursive internal `_walkpath!` function
    return Channel(; ctype=typeof(fp), csize=128) do chnl
        _walkpath!(root, root, Iterators.Stateful(objects), chnl; kwargs...)
    end
end

function _walkpath!(
    root::S3Path, prefix::S3Path, objects, chnl; topdown=true, onerror=throw, kwargs...
)
    @assert root.isdirectory
    @assert prefix.isdirectory

    while true
        try
            # Start by inspecting the next element
            obj = Base.peek(objects)

            # Early exit condition if we've exhausted the iterator or just the current prefix.
            obj === nothing && return nothing

            # Extract the non-root part of the key
            k = chop(obj["Key"]; head=length(root.key), tail=0)

            fp = joinpath(root, k)
            _parents = parents(fp)

            # If the filepath matches our prefix then pop it off and continue
            # Cause we would have already processed it before recursing
            child = if prefix.segments == fp.segments
                popfirst!(objects)
                continue
                # If the filpath is a direct descendant of our prefix then check if it
                # is a directory too
            elseif last(_parents) == prefix
                popfirst!(objects)
                # If our current path is a prefix for the next path then we can assume that
                # the current path should be a directory without needing to call `isdir`
                next = Base.peek(objects)
                is_dir =
                    (next !== nothing && startswith(next["Key"], fp.key)) || isdir(fp)
                # Reconstruct our next object and explicitly specify whether it is a
                # directory.
                S3Path(
                    fp.bucket,
                    fp.key;
                    isdirectory=is_dir,
                    config=fp.config,
                    version=fp.version,
                )
                # If our filepath is a distance descendant of the prefix then start filling in
                # the intermediate paths
            elseif prefix in _parents
                i = findfirst(==(prefix), _parents)
                _parents[i + 1]
                # Otherwise we've established that the current filepath isn't a descendant
                # of the prefix and we should exit
            else
                return nothing
            end

            # If we aren't dealing with the root and we're doing topdown iteration then
            # insert the child into the results channel
            !isempty(k) && topdown && put!(chnl, child)

            # Apply our recursive call for the children as necessary
            # NOTE: We're relying on the `isdirectory` field rather than calling `isdir`
            # which will call out to AWS as a fallback.
            if child.isdirectory
                _walkpath!(
                    root, child, objects, chnl; topdown=topdown, onerror=onerror, kwargs...
                )
            end

            # If we aren't dealing with the root and we're doing bottom up iteration then
            # insert the child ion the result channel here
            !isempty(k) && !topdown && put!(chnl, child)
        catch e
            isa(e, Base.IOError) ? onerror(e) : rethrow()
        end
    end
end

"""
    stat(fp::S3Path)

Return the status struct for the S3 path analogously to `stat` for local directories.

Note that this cannot be used on a directory.  This is because S3 is a pure key-value store and internally does
not have a concept of directories.  In some cases, a directory may actually be an empty file, in which case
you should use `s3_get_meta`.
"""
function Base.stat(fp::S3Path)
    # Currently AWSS3 would require a s3_get_acl call to fetch
    # ownership and permission settings
    m = Mode(; user=(READ + WRITE), group=(READ + WRITE), other=(READ + WRITE))
    u = FilePathsBase.User()
    g = FilePathsBase.Group()
    blksize = 4096
    blocks = 0
    s = 0
    last_modified = DateTime(0)

    if isfile(fp)
        resp = s3_get_meta(get_config(fp), fp.bucket, fp.key; version=fp.version)

        # Example: "Thu, 03 Jan 2019 21:09:17 GMT"
        last_modified = DateTime(
            get_robust_case(resp, "Last-Modified")[1:(end - 4)], dateformat"e, d u Y H:M:S"
        )
        s = parse(Int, get_robust_case(resp, "Content-Length"))
        blocks = ceil(Int, s / 4096)
    end

    return Status(0, 0, m, 0, u, g, 0, s, blksize, blocks, last_modified, last_modified)
end

"""
    diskusage(fp::S3Path)

Compute the *total* size of all contents of a directory.  Note that there is no direct functionality
for this in the S3 API so it may be slow.
"""
function FilePathsBase.diskusage(fp::S3Path)
    return if isfile(fp)
        stat(fp).size
    else
        s3_directory_stat(get_config(fp), fp.bucket, fp.key)[1]
    end
end

"""
    lastmodified(fp::S3Path)

Returns a `DateTime` corresponding to the latest time at which the object (or, in the case of a
directory, any contained object) was modified.
"""
function lastmodified(fp::S3Path)
    return if isfile(fp)
        stat(fp).mtime
    else
        s3_directory_stat(get_config(fp), fp.bucket, fp.key)[2]
    end
end

# Need API for accessing object ACL permissions for this to work
FilePathsBase.isexecutable(fp::S3Path) = false
Base.isreadable(fp::S3Path) = true
Base.iswritable(fp::S3Path) = true
Base.ismount(fp::S3Path) = false

"""
    mkdir(fp::S3Path; recursive=false, exist_ok=false)

Create an empty directory within an existing bucket for the S3 path `fp`. If `recursive`,
this will create any previously non-existent directories which would contain `fp`. An error
will be thrown if an object exists at `fp` unless `exist_ok`.

!!! note
    Creating a directory in [S3 creates a 0-byte object](https://docs.aws.amazon.com/AmazonS3/latest/userguide/using-folders.html)
    with a key set to the provided directory name.
"""
function Base.mkdir(fp::S3Path; recursive=false, exist_ok=false)
    fp.isdirectory || throw(ArgumentError("S3Path folders must end with '/': $fp"))

    if exists(fp)
        !exist_ok && error("$fp already exists.")
    else
        if hasparent(fp) && !exists(parent(fp))
            if recursive
                # don't try to create buckets this way, minio at least really doesn't like it
                isempty(parent(fp).segments) || mkdir(parent(fp); recursive, exist_ok)
            else
                error(
                    "The parent of $fp does not exist. " *
                    "Pass `recursive=true` to create it.",
                )
            end
        end

        write(fp, "")
    end

    return fp
end

function Base.rm(fp::S3Path; recursive=false, kwargs...)
    if isdir(fp)
        files = readpath(fp)

        if recursive
            for f in files
                rm(f; recursive, kwargs...)
            end
        elseif length(files) > 0
            error("S3 path $fp is not empty. Use `recursive=true` to delete.")
        end
    end

    @debug "delete: $fp"
    return s3_delete(fp)
end

s3_delete(fp::S3Path) = s3_delete(get_config(fp), fp.bucket, fp.key; fp.version)

"""
    s3_nuke_object(fp::S3Path)

Delete all versions of an object `fp`.
"""
function s3_nuke_object(fp::S3Path)
    return s3_nuke_object(get_config(fp), fp.bucket, fp.key)
end

# We need to special case sync with S3Paths because of how directories
# are handled again.
# NOTE: This method signature only makes sense with FilePathsBase 0.6.2, but
# 1) It'd be odd for other packages to restrict FilePathsBase to a patch release
# 2) Seems cleaner to have it fallback and error rather than having
# slightly inconsistent handling of edge cases between the two versions.
function FilePathsBase.sync(
    f::Function, src::AbstractPath, dst::S3Path; delete=false, overwrite=true
)
    # Throw an error if the source path doesn't exist at all
    exists(src) || throw(ArgumentError("Unable to sync from non-existent $src"))

    # If the top level source is just a file then try to just sync that
    # without calling walkpath
    if isfile(src)
        # If the destination exists then we should make sure it is a file and check
        # if we should copy the source over.
        if exists(dst)
            isfile(dst) || throw(ArgumentError("Unable to sync file $src to non-file $dst"))
            if overwrite && f(src, dst)
                cp(src, dst; force=true)
            end
        else
            cp(src, dst)
        end
    elseif isdir(src)
        if exists(dst)
            isdir(dst) ||
                throw(ArgumentError("Unable to sync directory $src to non-directory $dst"))
            # Create an index of all of the source files
            src_paths = collect(walkpath(src))

            #! format: off
            # https://github.com/domluna/JuliaFormatter.jl/issues/458
            index = Dict(
                Tuple(setdiff(p.segments, src.segments)) => i
                for (i, p) in enumerate(src_paths)
            )
            #! format: on

            for dst_path in walkpath(dst)
                k = Tuple(setdiff(dst_path.segments, dst.segments))

                if haskey(index, k)
                    src_path = src_paths[pop!(index, k)]
                    if overwrite && f(src_path, dst_path)
                        cp(src_path, dst_path; force=true)
                    end
                elseif delete
                    rm(dst_path; recursive=true)
                end
            end

            # Finally, copy over files that don't exist at the destination
            # But we need to iterate through it in a way that respects the original
            # walkpath order otherwise we may end up trying to copy a file before its parents.
            index_pairs = collect(pairs(index))
            index_pairs = index_pairs[sortperm(index_pairs; by=last)]
            for (seg, i) in index_pairs
                new_dst = S3Path(
                    tuple(dst.segments..., seg...),
                    dst.root,
                    dst.drive,
                    isdir(src_paths[i]),
                    nothing,
                    dst.config,
                )

                cp(src_paths[i], new_dst; force=true)
            end
        else
            cp(src, dst)
        end
    else
        throw(ArgumentError("$src is neither a file or directory."))
    end
end

# for some reason, sometimes we get back a `Pair`
# other times a `AbstractDict`.
function _pair_or_dict_get(p::Pair, k)
    first(p) == k || return nothing
    return last(p)
end
_pair_or_dict_get(d::AbstractDict, k) = get(d, k, nothing)

function _retrieve_prefixes!(results, objects, prefix_key, chop_head)
    objects === nothing && return nothing

    rm_key = s -> chop(s; head=chop_head, tail=0)

    for p in objects
        prefix = _pair_or_dict_get(p, prefix_key)

        if prefix !== nothing
            push!(results, rm_key(prefix))
        end
    end

    return nothing
end

function _readdir_add_results!(results, response, key_length)
    sizehint!(results, length(results) + parse(Int, response["KeyCount"]))

    common_prefixes = get(response, "CommonPrefixes", nothing)
    _retrieve_prefixes!(results, common_prefixes, "Prefix", key_length)

    contents = get(response, "Contents", nothing)
    _retrieve_prefixes!(results, contents, "Key", key_length)

    return get(response, "NextContinuationToken", nothing)
end

function Base.readdir(fp::S3Path; join=false, sort=true)
    if isdir(fp)
        k = fp.key
        key_length = length(k)
        results = String[]
        token = ""
        while token !== nothing
            response = @repeat 4 try
                params = Dict("delimiter" => "/", "prefix" => k)

                if !isempty(token)
                    params["continuation-token"] = token
                end
                parse(S3.list_objects_v2(fp.bucket, params; aws_config=get_config(fp)))
            catch e
                #! format: off
                @delay_retry if ecode(e) in ["NoSuchBucket"] end
                #! format: on
            end
            token = _readdir_add_results!(results, response, key_length)
        end

        # Filter out any empty object names which are valid in S3
        filter!(!isempty, results)

        # Sort results if sort=true
        sort && sort!(results)

        # Return results, possibly joined with the root path if join=true
        return join ? joinpath.(fp, results) : results
    else
        throw(ArgumentError("\"$fp\" is not a directory"))
    end
end

"""
    read(fp::S3Path; byte_range=nothing)

Fetch data from the S3 path as a `Vector{UInt8}`.  A subset of the object can be specified with
`byte_range` which should be a contiguous integer range, e.g. `1:4`.
"""
function Base.read(fp::S3Path; byte_range=nothing)
    return Vector{UInt8}(
        s3_get(
            get_config(fp),
            fp.bucket,
            fp.key;
            raw=true,
            byte_range=byte_range,
            version=fp.version,
        ),
    )
end

"""
    Base.write(fp::S3Path, content::String; kwargs...)
    Base.write(fp::S3Path, content::Vector{UInt8}; part_size_mb=50, multipart::Bool=true,
               returns::Symbol=:parsed, other_kwargs...,)

Write `content` to S3Path `fp`.

# Optional Arguments
- `multipart`: when `true`, uploads data via [`s3_multipart_upload`](@ref) for `content`
  greater than `part_size_mb` bytes; when false, or when `content` is shorter
  than `part_size_mb`, uploads data via [`s3_put`](@ref).
- `part_size_mb`: when `multipart=true`, sets maximum length of partitioned data (in bytes).
- `returns`: determines the result returned by the function: `:response` (the AWS API
  response), :parsed` (default; the parsed AWS API response), or `:path` (the newly created
  [`S3Path`](@ref), including its `version` when versioning is enabled for the bucket).
- `other_kwargs`: additional kwargs passed through into [`s3_multipart_upload`](@ref).
"""
function Base.write(fp::S3Path, content::String; kwargs...)
    return Base.write(fp, Vector{UInt8}(content); kwargs...)
end

function Base.write(
    fp::S3Path,
    content::Vector{UInt8};
    part_size_mb=50,
    multipart::Bool=true,
    returns::Symbol=:parsed,
    other_kwargs...,
)
    # avoid HTTPClientError('An HTTP Client raised an unhandled exception: string longer than 2147483647 bytes')
    MAX_HTTP_BYTES = 2147483647
    if fp.version !== nothing
        throw(ArgumentError("Can't write to a specific object version ($(fp.version))"))
    end

    supported_return_values = (:parsed, :response, :path)
    if !(returns in supported_return_values)
        err = "Unsupported `returns` value `$returns`; supported options are `$(supported_return_values)`"
        throw(ArgumentError(err))
    end

    config = get_config(fp)
    response = if !multipart || length(content) < MAX_HTTP_BYTES
        s3_put(config, fp.bucket, fp.key, content; parse_response=false)
    else
        io = IOBuffer(content)
        s3_multipart_upload(
            config,
            fp.bucket,
            fp.key,
            io,
            part_size_mb;
            parse_response=false,
            other_kwargs...,
        )
    end

    if returns == :path
        return S3Path(
            fp.bucket,
            fp.key;
            isdirectory=fp.isdirectory,
            version=HTTP.header(response.headers, "x-amz-version-id", nothing),
            config=fp.config,
        )
    elseif returns == :parsed
        return parse(response)
    else
        return response
    end
end

function FilePathsBase.mktmpdir(parent::S3Path)
    fp = parent / string(uuid4(), "/")
    return mkdir(fp)
end

const S3PATH_ARROW_NAME = Symbol("JuliaLang.AWSS3.S3Path")
ArrowTypes.arrowname(::Type{<:S3Path}) = S3PATH_ARROW_NAME
ArrowTypes.ArrowType(::Type{<:S3Path}) = String
ArrowTypes.JuliaType(::Val{S3PATH_ARROW_NAME}, ::Any) = S3Path{Nothing}
ArrowTypes.fromarrow(::Type{<:S3Path}, uri_string) = S3Path(uri_string)

function ArrowTypes.toarrow(path::S3Path)
    if !isnothing(path.config)
        throw(ArgumentError("`S3Path` config must be `nothing` to serialize to Arrow"))
    end
    return string(path)
end

# HTTP.jl only defines its own `VERSION` constant in 2.x; in 1.x `AWS.HTTP.VERSION`
# is the binding re-exported from `Base` (Julia's version), so check that `VERSION`
# is actually owned by the `HTTP` module before trusting it.
const _HTTP_V2 =
    Base.binding_module(AWS.HTTP, :VERSION) === AWS.HTTP && v"2" <= AWS.HTTP.VERSION < v"3"

function test_s3_constructors(ps::PathSet)
    bucket_name = ps.root.bucket
    @test S3Path(bucket_name, "pathset-root/foo/baz.txt") == ps.baz
    @test S3Path(bucket_name, p"pathset-root/foo/baz.txt") == ps.baz
    @test S3Path(bucket_name, p"/pathset-root/foo/baz.txt") == ps.baz
    @test S3Path("s3://$bucket_name", p"/pathset-root/foo/baz.txt") == ps.baz
    @test S3Path(bucket_name, "pathset-root/bar/qux"; isdirectory=true) == ps.qux
    @test S3Path(bucket_name, "pathset-root/bar/qux/"; isdirectory=true) == ps.qux
    @test S3Path(bucket_name, p"pathset-root/bar/qux"; isdirectory=true) == ps.qux
    @test S3Path(bucket_name, p"/pathset-root/bar/qux"; isdirectory=true) == ps.qux
    @test S3Path("s3://$bucket_name/pathset-root/bar/qux"; isdirectory=true) == ps.qux
end

function test_s3_parents(ps::PathSet)
    @testset "parents" begin
        @test parent(ps.foo) == ps.root
        @test parent(ps.qux) == ps.bar
        @test dirname(ps.foo) == ps.root

        @test hasparent(ps.qux)
        _parents = parents(ps.qux)
        @test _parents[end] == ps.bar
        @test _parents[end - 1] == ps.root
        @test _parents[1] == Path(ps.root; segments=())
    end
end

function test_s3_join(ps::PathSet)
    @testset "join" begin
        @test join(ps.root, "bar/") == ps.bar
        @test ps.root / "foo" / "baz.txt" == ps.baz
        @test ps.root / "foobaz.txt" == ps.root / "foo" * "baz.txt"
    end
end

function test_s3_normalize(ps::PathSet)
    @testset "norm" begin
        @test normalize(ps.bar / ".." / "foo/") == ps.foo
        @test normalize(ps.bar / ".." / "foo") != ps.foo
        @test normalize(ps.bar / "./") == ps.bar
        @test normalize(ps.bar / "../") == ps.root
    end
end

function test_s3_mkdir(p::PathSet)
    @testset "mkdir" begin
        garply = p.root / "corge" / "grault" / "garply/"
        mkdir(garply; recursive=true)
        @test exists(garply)
        rm(p.root / "corge/"; recursive=true)
        @test !exists(garply)
    end
end

function test_s3_download(base_config::AbstractAWSConfig)
    config = assume_testset_role("ReadWriteObject"; base_config)

    # Requires that the global AWS configuration is set so that `S3Path`s created within
    # the tests have the correct permissions (e.g. `download(::S3Path, "s3://...")`)
    return p -> with_aws_config(config) do
        test_download(p)
    end
end

function test_s3_readpath(p::PathSet)
    @testset "readpath" begin
        @test readdir(p.root) == ["bar/", "foo/", "fred/"]
        @test readdir(p.qux) == ["quux.tar.gz"]
        @test readpath(p.root) == [p.bar, p.foo, p.fred]
        @test readpath(p.qux) == [p.quux]
    end
end

function test_s3_walkpath(p::PathSet)
    @testset "walkpath - S3" begin
        # Test that we still return parent prefixes even when no "directory" objects
        # have been created by a `mkdir`, retaining consistency with `readdir`.
        _root = p.root / "s3_walkpath/"

        _foo = _root / "foo/"
        _baz = _foo / "baz.txt"
        _bar = _root / "bar/"
        _qux = _bar / "qux/"
        _quux = _qux / "quux.tar.gz"

        # Only write the leaf files
        write(_baz, read(p.baz))
        write(_quux, read(p.quux))

        topdown = [_bar, _qux, _quux, _foo, _baz]
        bottomup = [_quux, _qux, _bar, _baz, _foo]

        @test collect(walkpath(_root; topdown=true)) == topdown
        @test collect(walkpath(_root; topdown=false)) == bottomup

        rm(_root; recursive=true)
    end
end

function test_s3_cp(p::PathSet)
    @testset "cp" begin
        # In case the folder objects were deleted in a previous test
        mkdir.([p.foo, p.qux, p.fred]; recursive=true, exist_ok=true)
        @test exists(p.foo)
        cp(p.foo, p.qux / "foo/"; force=true)
        @test exists(p.qux / "foo" / "baz.txt")
        rm(p.qux / "foo/"; recursive=true)
    end
end

function test_s3_mv(p::PathSet)
    @testset "mv" begin
        # In case the folder objects were deleted in a previous test
        mkdir.([p.foo, p.qux, p.fred]; recursive=true, exist_ok=true)
        garply = p.root / "corge" / "grault" / "garply/"
        mkdir(garply; recursive=true, exist_ok=true)
        @test exists(garply)
        mv(p.root / "corge/", p.foo / "corge/"; force=true)
        @test exists(p.foo / "corge" / "grault" / "garply/")
        rm(p.foo / "corge/"; recursive=true)
    end
end

function test_s3_sync(ps::PathSet)
    return p -> @testset "sync" begin
        # In case the folder objects were deleted in a previous test
        mkdir.([p.foo, p.qux, p.fred]; recursive=true, exist_ok=true)
        # Base cp case
        sync(p.foo, ps.qux / "foo/")
        @test exists(p.qux / "foo" / "baz.txt")

        # Test that the copied baz file has a newer modified time
        baz_t = modified(p.qux / "foo" / "baz.txt")
        @test modified(p.baz) < baz_t

        # Don't cp unchanged files when a new file is added
        # NOTE: sleep before we make a new file, so it's clear tha the
        # modified time has changed.
        sleep(1)
        write(p.foo / "test.txt", "New File")
        sync(p.foo, ps.qux / "foo/")
        @test exists(p.qux / "foo" / "test.txt")
        @test read(p.qux / "foo" / "test.txt") == b"New File"
        @test read(p.qux / "foo" / "test.txt", String) == "New File"
        @test modified(p.qux / "foo" / "baz.txt") == baz_t
        @test modified(p.qux / "foo" / "test.txt") > baz_t

        # Test not deleting a file on sync
        rm(p.foo / "test.txt")
        sync(p.foo, ps.qux / "foo/")
        @test exists(p.qux / "foo" / "test.txt")

        # Test passing delete flag
        sync(p.foo, p.qux / "foo/"; delete=true)
        @test !exists(p.qux / "foo" / "test.txt")
        rm(p.qux / "foo/"; recursive=true)
    end
end

function test_s3_properties(base_config::AbstractAWSConfig)
    return ps -> @testset "s3_properties" begin
        config = assume_testset_role("ReadWriteObject"; base_config)

        fp1 = S3Path("s3://mybucket/path/to/some/object"; config)
        fp2 = S3Path("s3://mybucket/path/to/some/prefix/"; config)
        @test fp1.bucket == "mybucket"
        @test fp1.key == "path/to/some/object"
        @test fp2.bucket == "mybucket"
        @test fp2.key == "path/to/some/prefix/"
        @test fp2.version === nothing

        try
            fp3 = S3Path(ps.root.bucket, "/another/testdir/"; config)
            strs = ["what up", "what else up", "what up again"]
            write(fp3 / "testfile1.txt", strs[1])
            write(fp3 / "testfile2.txt", strs[2])
            write(fp3 / "inner" / "testfile3.txt", strs[3])
            @test AWSS3.diskusage(fp3) == sum(ncodeunits.(strs))

            # we deliberately pick an older file to compare to so we
            # can be confident timestamps are different
            @test AWSS3.lastmodified(fp3) > AWSS3.lastmodified(ps.foo)
        finally
            rm(S3Path(ps.root.bucket, "/another/"; config); recursive=true)  # otherwise subsequent tests may fail
        end
    end
end

function test_s3_folders_and_files(ps::PathSet)
    config = ps.root.config
    @testset "s3_folders_and_files" begin
        # Minio has slightly different semantics than s3 in that it does
        # not support having prefixes that clash with files
        # (https://github.com/minio/minio/issues/9865)
        # Thus in these tests, we run certain tests only on s3.

        # In case the ps.root doesn't exist
        mkdir(ps.root; recursive=true, exist_ok=true)

        # Test that the trailing slash matters
        @test p"s3://mybucket/path/to/some/prefix/" != p"s3://mybucket/path/to/some/prefix"

        # Test that we can have empty directory names
        # I'm not sure if we want to support this in the future, but it may require more
        # overloading of AbstractPath methods to support properly.
        @test_broken p"s3://mybucket/path/to/some/prefix" !=
            p"s3://mybucket/path//to/some/prefix"

        write(ps.root / "foobar", "I'm an object")
        if is_aws(config)
            mkdir(ps.root / "foobar/")
            write(ps.root / "foobar" / "car.txt", "I'm a different object")
        end

        @test read(ps.root / "foobar") == b"I'm an object"
        @test read(ps.root / "foobar", String) == "I'm an object"
        @test_throws ArgumentError readpath(ps.root / "foobar")
        if is_aws(config)
            @test readpath(ps.root / "foobar/") == [ps.root / "foobar" / "car.txt"]
            @test read(ps.root / "foobar" / "car.txt", String) == "I'm a different object"
        end
    end
end

function test_multipart_write(ps::PathSet)
    teststr = repeat("This is a test string!", round(Int, 2e5))
    @testset "multipart write/read" begin
        result = write(ps.quux, teststr; part_size_mb=1, multipart=true)
        @test read(ps.quux, String) == teststr
        @test result == UInt8[]
    end

    @testset "multipart write/read, return path" begin
        result = write(ps.quux, teststr; part_size_mb=1, multipart=true, returns=:path)
        @test read(ps.quux, String) == teststr
        @test isa(result, S3Path)
    end

    @testset "multipart write/read, return response" begin
        result = write(ps.quux, teststr; part_size_mb=1, multipart=true, returns=:response)
        @test read(ps.quux, String) == teststr
        @test isa(result, AWS.Response)
    end
end

function test_write_returns(ps::PathSet)
    @testset "write returns" begin
        teststr = "Test string"
        @test write(ps.quux, teststr) == UInt8[]
        @test write(ps.quux, teststr; returns=:parsed) == UInt8[]
        @test write(ps.quux, teststr; returns=:response) isa AWS.Response
        @test write(ps.quux, teststr; returns=:path) isa S3Path
        @test_throws ArgumentError write(ps.quux, teststr; returns=:unsupported_return_type)
    end
end

function initialize(config, bucket_name)
    """
    Hierarchy:

    bucket-name
    |-- test_01.txt
    |-- emptydir/
    |-- subdir1/
    |   |-- test_02.txt
    |   |-- test_03.txt
    |   |-- subdir2/
    |       |-- test_04.txt
    |       |-- subdir3/
    """
    s3_put(config, bucket_name, "test_01.txt", "test01")
    s3_put(config, bucket_name, "emptydir/", "")
    s3_put(config, bucket_name, "subdir1/", "")
    s3_put(config, bucket_name, "subdir1/test_02.txt", "test02")
    s3_put(config, bucket_name, "subdir1/test_03.txt", "test03")
    s3_put(config, bucket_name, "subdir1/subdir2/", "")
    s3_put(config, bucket_name, "subdir1/subdir2/test_04.txt", "test04")
    return s3_put(config, bucket_name, "subdir1/subdir2/subdir3/", "")
end

function verify_files(path::S3Path)
    @test readdir(path) == ["emptydir/", "subdir1/", "test_01.txt"]
    @test readdir(path; join=true) ==
        [path / "emptydir/", path / "subdir1/", path / "test_01.txt"]
    @test readdir(path / "emptydir/") == []
    @test readdir(path / "emptydir/"; join=true) == []
    @test readdir(path / "subdir1/") == ["subdir2/", "test_02.txt", "test_03.txt"]
    @test readdir(path / "subdir1/"; join=true) == [
        path / "subdir1/" / "subdir2/",
        path / "subdir1/" / "test_02.txt",
        path / "subdir1/" / "test_03.txt",
    ]
    @test readdir(path / "subdir1/subdir2/") == ["subdir3/", "test_04.txt"]
    @test readdir(path / "subdir1/subdir2/"; join=true) == [
        path / "subdir1/subdir2/" / "subdir3/", path / "subdir1/subdir2/" / "test_04.txt"
    ]
    @test readdir(path / "subdir1/subdir2/subdir3/") == []
    @test readdir(path / "subdir1/subdir2/subdir3/"; join=true) == []
end

function verify_files(path::AbstractPath)
    @test readdir(path) == ["emptydir", "subdir1", "test_01.txt"]
    @test readdir(path; join=true) ==
        [path / "emptydir", path / "subdir1", path / "test_01.txt"]
    @test readdir(path / "emptydir/") == []
    @test readdir(path / "emptydir/"; join=true) == []
    @test readdir(path / "subdir1/") == ["subdir2", "test_02.txt", "test_03.txt"]
    @test readdir(path / "subdir1/"; join=true) == [
        path / "subdir1" / "subdir2",
        path / "subdir1" / "test_02.txt",
        path / "subdir1/" / "subdir1/test_03.txt",
    ]
    @test readdir(path / "subdir1/subdir2/") == ["subdir3", "test_04.txt"]
    @test readdir(path / "subdir1/subdir2/"; join=true) ==
        [path / "subdir1/subdir2/" / "subdir3", path / "subdir1/subdir2/" / "test_04.txt"]
    @test readdir(path / "subdir1/subdir2/subdir3/") == []
    @test readdir(path / "subdir1/subdir2/subdir3/"; join=true) == []
end

# This is the main entrypoint for the S3Path tests
function s3path_tests(base_config)
    bucket_name = gen_bucket_name()

    let
        config = assume_testset_role("CreateBucket"; base_config)
        s3_create_bucket(config, bucket_name)
    end

    root = let
        config = assume_testset_role("ReadWriteObject"; base_config)
        S3Path("s3://$bucket_name/pathset-root/"; config)
    end

    ps = PathSet(
        root,
        root / "foo/",
        root / "foo" / "baz.txt",
        root / "bar/",
        root / "bar" / "qux/",
        root / "bar" / "qux" / "quux.tar.gz",
        root / "fred/",
        root / "fred" / "plugh",
        false,
    )

    @testset "$(typeof(ps.root))" begin
        testsets = [
            test_s3_constructors,
            test_registration,
            test_show,
            test_parse,
            test_convert,
            test_components,
            test_indexing,
            test_iteration,
            test_s3_parents,
            test_descendants_and_ascendants,
            test_s3_join,
            test_splitext,
            test_basename,
            test_filename,
            test_extensions,
            test_isempty,
            test_s3_normalize,
            # test_canonicalize, # real doesn't make sense for S3Paths
            test_relative,
            test_absolute,
            test_isdir,
            test_isfile,
            test_stat,
            test_filesize,
            test_modified,
            test_created,
            test_cd,
            test_s3_readpath,
            test_walkpath,
            test_read,
            test_multipart_write,
            test_write,
            test_write_returns,
            test_s3_mkdir,
            # These tests seem to fail due to an eventual consistency issue?
            test_s3_cp,
            test_s3_mv,
            test_s3_sync(ps),
            test_symlink,
            test_touch,
            test_tmpname,
            test_tmpdir,
            test_mktmp,
            test_mktmpdir,
            test_s3_download(base_config),
            test_issocket,
            # These will also all work for our custom path type,
            # but many implementations won't support them.
            test_isfifo,
            test_ischardev,
            test_isblockdev,
            test_ismount,
            test_isexecutable,
            test_isreadable,
            test_iswritable,
            # test_chown,   # chmod & chown don't make sense for S3Paths
            # test_chmod,
            test_s3_properties(base_config),
            test_s3_folders_and_files,
        ]

        # Run all of the automated tests
        #
        # Note: `FilePathsBase.TestPaths.test` internally calls an `initialize` function
        # which requires AWS permissions in order to write some files to S3. Due to this
        # setup and how `test` passes in `ps` to each test it makes it hard to have each
        # testset specify their required permissions separately. Currently, we embed the
        # configuration in the paths themselves but it may make more sense to set the
        # config globally temporarily via `with_aws_config`.
        test(ps, testsets)
    end

    @testset "readdir" begin
        config = assume_testset_role("ReadWriteObject"; base_config)
        initialize(config, bucket_name)

        @testset "S3" begin
            verify_files(S3Path("s3://$bucket_name/"; config))
            @test_throws ArgumentError("Invalid s3 path string: $bucket_name") S3Path(
                bucket_name
            )
        end

        @test_skip @testset "Local" begin
            temp_path = Path(tempdir() * string(uuid4()))
            mkdir(temp_path)

            sync(S3Path("s3://$bucket_name/"; config), temp_path)
            verify_files(temp_path)

            rm(temp_path; force=true, recursive=true)
        end

        @testset "join" begin
            @test (  # test trailing slash on prefix does not matter for join
                p"s3://foo/bar" / "baz" == p"s3://foo/bar/" / "baz" == p"s3://foo/bar/baz"
            )
            @test (  # test trailing slash on root-only prefix in particular does not matter
                p"s3://foo" / "bar" / "baz" ==
                p"s3://foo/" / "bar" / "baz" ==
                p"s3://foo/bar/baz"
            )
            # test extra leading and trailing slashes do not matter
            @test p"s3://foo/" / "bar/" / "/baz" == p"s3://foo/bar/baz"
            # test joining `/` and string concatentation `*` play nice as expected
            @test p"s3://foo" * "/" / "bar" ==
                p"s3://foo" / "/" * "bar" ==
                p"s3://foo" / "bar"
            @test p"s3://foo" / "bar" * "baz" ==
                p"s3://foo/bar" * "baz" ==
                p"s3://foo" / "barbaz"
            # test trailing slash on final piece is included
            @test p"s3://foo/bar" / "baz/" == p"s3://foo/bar/baz/"
        end

        @testset "readdir" begin
            path = S3Path("s3://$(bucket_name)/A/A/B.txt"; config)
            write(path, "test!")
            results = readdir(S3Path("s3://$(bucket_name)/A/"; config))

            @test results == ["A/"]
        end
    end

    @testset "isdir" begin
        config = assume_testset_role("ReadObject"; base_config)

        function _generate_exception(code)
            # `StatusError` moved out of the `Exceptions` submodule in HTTP.jl 2.0 and
            # its constructor changed from `(status, method, target, response)` to
            # `(status, response)`.
            status_error = if _HTTP_V2
                AWS.HTTP.StatusError(404, AWS.HTTP.Response(404))
            else
                AWS.HTTP.Exceptions.StatusError(404, "", "", "")
            end
            return AWSException(code, "", nothing, status_error, nothing)
        end

        @testset "top level bucket" begin
            @testset "success" begin
                @test isdir(S3Path("s3://$(bucket_name)"; config))
                @test isdir(S3Path("s3://$(bucket_name)/"; config))
            end

            @testset "NoSuchBucket" begin
                test_exception = _generate_exception("NoSuchBucket")
                patch = @patch function AWSS3.S3.list_objects_v2(args...; kwargs...)
                    throw(test_exception)
                end

                apply(patch) do
                    @test !isdir(S3Path("s3://$(bucket_name)"; config))
                    @test !isdir(S3Path("s3://$(bucket_name)/"; config))
                end
            end

            @testset "Other Exception" begin
                test_exception = _generate_exception("TestException")
                patch = @patch function AWSS3.S3.list_objects_v2(args...; kwargs...)
                    throw(test_exception)
                end

                apply(patch) do
                    @test_throws AWSException isdir(S3Path("s3://$(bucket_name)"; config))
                    @test_throws AWSException isdir(S3Path("s3://$(bucket_name)/"; config))
                end
            end
        end

        # Based upon this example: https://repost.aws/knowledge-center/iam-s3-user-specific-folder
        #
        # MinIO isn't currently setup with the restrictive prefix required to make the tests
        # fail with "AccessDenied".
        is_aws(base_config) && @testset "Restricted Prefix" begin
            setup_config = assume_testset_role("ReadWriteObject"; base_config)
            s3_put(
                setup_config,
                bucket_name,
                "prefix/denied/secrets/top-secret",
                "for british eyes only",
            )
            s3_put(setup_config, bucket_name, "prefix/granted/file", "hello")

            config = assume_testset_role("RestrictedPrefixTestset"; base_config)
            @test isdir(S3Path("s3://$(bucket_name)/prefix/granted/"; config))
            @test isdir(S3Path("s3://$(bucket_name)/prefix/"; config))
            @test isdir(S3Path("s3://$(bucket_name)"; config))

            @test_throws_msg ["AccessDenied", "403"] begin
                isdir(S3Path("s3://$(bucket_name)/prefix/denied/"; config))
            end

            # The above call fails as we use `"prefix" => "prefix/denied/"`. However,
            # this restricted role can still determine that the "denied" directory
            # exists with some carefully crafted queries.
            params = Dict("prefix" => "prefix/", "delimiter" => "/")
            r = S3.list_objects_v2(bucket_name, params; aws_config=config)
            prefixes = [x["Prefix"] for x in parse(r)["CommonPrefixes"]]
            @test "prefix/denied/" in prefixes

            @test_throws_msg ["AccessDenied", "403"] begin
                !isdir(S3Path("s3://$(bucket_name)/prefix/dne/"; config))
            end

            @test_throws_msg ["AccessDenied", "403"] begin
                !isdir(S3Path("s3://$(bucket_name)/prefix/denied/secrets/"; config))
            end
        end
    end

    @testset "JSON roundtripping" begin
        config = assume_testset_role("ReadWriteObject"; base_config)

        json_path = S3Path("s3://$(bucket_name)/test_json"; config)
        my_dict = Dict("key" => "value", "key2" => 5.0)
        # here we use the "application/json" MIME type to trigger the heuristic parsing into a `LittleDict`
        # that will hit a `MethodError` at the `Vector{UInt8}` constructor of `read(::S3Path)` if `raw=true`
        # was not passed to `s3_get` in that method.
        result = s3_put(
            config, bucket_name, "test_json", JSON3.write(my_dict), "application/json"
        )
        @test result == UInt8[]
        json_bytes = read(json_path)
        @test JSON3.read(json_bytes, Dict) == my_dict
        rm(json_path)
    end

    @testset "Arrow <-> S3Path (de)serialization" begin
        ver = String('A':'Z') * String('0':'5')
        paths = Union{Missing,S3Path}[
            missing,
            S3Path("s3://$(bucket_name)/a"),
            S3Path("s3://$(bucket_name)/b?versionId=$ver"),
            # format trick: using this comment to force use of multiple lines
        ]
        tbl = Arrow.Table(Arrow.tobuffer((; paths=paths)))
        @test all(isequal.(tbl.paths, paths))

        # Cannot serialize `S3Path`s with embedded `AWSConfig`s.
        push!(paths, S3Path("s3://$(bucket_name)/c"; config=base_config))
        @test_throws ArgumentError Arrow.tobuffer((; paths))
    end

    @testset "tryparse" begin
        # The global `AWSConfig` is just used for comparison and isn't used for access
        cfg = global_aws_config()
        ver = String('A':'Z') * String('0':'5')

        @test S3Path("s3://my_bucket/prefix/path") ==
            S3Path(("prefix", "path"), "/", "s3://my_bucket", false, nothing, cfg)

        @test S3Path("s3://my_bucket/prefix/path/") ==
            S3Path(("prefix", "path"), "/", "s3://my_bucket", true, nothing, cfg)

        @test S3Path("s3://my_bucket/") ==
            S3Path((), "/", "s3://my_bucket", true, nothing, cfg)

        @test S3Path("s3://my_bucket") ==
            S3Path((), "", "s3://my_bucket", true, nothing, cfg)

        @test S3Path("s3://my_bucket/prefix/path?versionId=$ver") ==
            S3Path(("prefix", "path"), "/", "s3://my_bucket", false, ver, cfg)

        @test S3Path("s3://my_bucket/prefix/path/?versionId=$ver") ==
            S3Path(("prefix", "path"), "/", "s3://my_bucket", true, ver, cfg)

        @test S3Path("s3://my_bucket/?versionId=$ver") ==
            S3Path((), "/", "s3://my_bucket", true, ver, cfg)

        @test S3Path("s3://my_bucket?versionId=$ver") ==
            S3Path((), "", "s3://my_bucket", true, ver, cfg)

        @test S3Path("s3://my_bucket/prefix/path/?versionId=$ver&radtimes=foo") ==
            S3Path(("prefix", "path"), "/", "s3://my_bucket", true, ver, cfg)

        @test S3Path("s3://my_bucket/prefix/path/?radtimes=foo&versionId=$ver") ==
            S3Path(("prefix", "path"), "/", "s3://my_bucket", true, ver, cfg)

        @test S3Path("s3://my_bucket/prefix/path?versionId=null") ==
            S3Path(("prefix", "path"), "/", "s3://my_bucket", false, "null", cfg)

        # Test to mark inconsistent root string behaviour when reconstructing parsed paths.
        parsed = tryparse(S3Path, "s3://my_bucket")
        @test_broken parsed == S3Path(
            parsed.bucket, parsed.key; version=parsed.version, config=parsed.config
        )

        @test_throws ArgumentError S3Path("s3://my_bucket/?versionId=")
        @test_throws ArgumentError S3Path("s3://my_bucket/?versionId=xyz")
    end

    @testset "version is empty" begin
        @test_throws ArgumentError S3Path("my_bucket", "path"; version="")
        @test_throws ArgumentError S3Path("s3://my_bucket/"; version="")
    end

    @testset "construct S3Path from S3Path" begin
        # Use custom config to test that config is preserved in construction
        config = AWSConfig(; region="bogus")
        path = S3Path("s3://my_bucket/prefix"; config)

        # When no kwargs provided, return identity
        @test S3Path(path) === path

        # version kwarg overrides path.version
        version = String('A':'Z') * String('0':'5')
        p = S3Path(path; version)
        @test p != path
        @test p.bucket == path.bucket
        @test p.key == path.key
        @test p.config == path.config
        @test p.version == version != path.version

        # ...if version already exists, overwrite silently
        path_versioned = S3Path(path; version)
        alt_version = String('0':'5') * String('A':'Z')
        p = S3Path(path_versioned; version=alt_version)
        @test p.version == alt_version != path_versioned.version

        # config kwarg overrides path.config
        alt_config = AWSConfig(; region="foo")
        p = S3Path(path; config=alt_config)
        @test p.config == alt_config != path.config

        # isdirectory kwarg overrides path.config
        p = S3Path(path; isdirectory=!path.isdirectory)
        @test p.isdirectory != path.isdirectory
    end

    # `s3_list_versions` gives `SignatureDoesNotMatch` exceptions on Minio
    if is_aws(base_config)
        @testset "S3Path versioning" begin
            config = assume_testset_role("S3PathVersioningTestset"; base_config)

            s3_enable_versioning(config, bucket_name)
            key = "test_versions"
            r1 = s3_put(config, bucket_name, key, "data.v1"; parse_response=false)
            r2 = s3_put(config, bucket_name, key, "data.v2"; parse_response=false)
            rv1 = HTTP.header(r1.headers, "x-amz-version-id", nothing)
            rv2 = HTTP.header(r2.headers, "x-amz-version-id", nothing)

            # `s3_list_versions` returns versions in the order newest to oldest
            listed_versions = s3_list_versions(config, bucket_name, key)
            versions = [d["VersionId"] for d in reverse!(listed_versions)]

            v1, v2 = first(versions), last(versions)
            @test v1 == rv1
            @test v2 == rv2
            @test read(S3Path(bucket_name, key; config, version=v1), String) == "data.v1"
            @test read(S3Path(bucket_name, key; config, version=v2), String) == "data.v2"
            @test read(S3Path(bucket_name, key; config, version=v2), String) ==
                read(S3Path(bucket_name, key; config), String)
            @test read(S3Path(bucket_name, key; config, version=v2), String) ==
                read(S3Path(bucket_name, key; config, version=nothing), String)

            unversioned_path = S3Path(bucket_name, key; config)
            versioned_path = S3Path(bucket_name, key; config, version=v2)
            @test versioned_path.version == v2
            @test unversioned_path.version === nothing
            @test exists(versioned_path)
            @test exists(unversioned_path)

            dne = "feVMBvDgNiKSpMS17fKNJK3GV05bl8ir"
            dne_versioned_path = S3Path(bucket_name, key; config, version=dne)
            @test !exists(dne_versioned_path)

            versioned_path_v1 = S3Path("s3://$bucket_name/$key"; version=v1)
            versioned_path_v2 = S3Path("s3://$bucket_name/$key"; version=v2)
            @test versioned_path_v1.version == v1
            @test versioned_path_v1 != unversioned_path
            @test versioned_path_v1 != versioned_path_v2

            versioned_path_v1_from_url = S3Path("s3://$bucket_name/$key?versionId=$v1")
            @test versioned_path_v1_from_url.key == key
            @test versioned_path_v1_from_url.version == v1
            @test S3Path("s3://$bucket_name/$key?versionId=$v1"; version=v1).version == v1
            @test_throws ArgumentError begin
                S3Path("s3://$bucket_name/$key?versionId=$v1"; version=v2)
            end

            str_v1 = string(versioned_path_v1)
            roundtripped_v1 = S3Path(str_v1; config)
            @test isequal(versioned_path_v1, roundtripped_v1)
            @test str_v1 == "s3://" * bucket_name * "/" * key * "?versionId=" * v1

            @test isa(stat(versioned_path), Status)
            @test_throws ArgumentError write(versioned_path, "new_content")

            rm(versioned_path)
            @test !exists(versioned_path)
            @test length(s3_list_versions(config, bucket_name, key)) == 1

            fp = S3Path(bucket_name, "test_versions_nukeobject"; config)
            foreach(_ -> write(fp, "foo"), 1:6)
            @test length(s3_list_versions(fp.config, fp.bucket, fp.key)) == 6
            s3_nuke_object(fp)
            @test length(s3_list_versions(fp.config, fp.bucket, fp.key)) == 0
            @test !exists(fp)
        end

        @testset "S3Path null version" begin
            config = assume_testset_role("S3PathNullVersionTestset"; base_config)

            b = gen_bucket_name("awss3.jl.test.null.")
            k = "object"

            function versioning_enabled(config, bucket)
                d = parse(S3.get_bucket_versioning(bucket; aws_config=config))
                return get(d, "Status", "Disabled") == "Enabled"
            end

            function list_version_ids(args...)
                return [d["VersionId"] for d in reverse!(s3_list_versions(args...))]
            end

            try
                # Create a new bucket that we know does not have versioning enabled
                s3_create_bucket(config, b)
                @test !versioning_enabled(config, b)

                # Create an object which will have versionId set to "null"
                r1 = s3_put(config, b, k, "original"; parse_response=false)
                rv1 = HTTP.header(r1.headers, "x-amz-version-id", nothing)
                @test isnothing(rv1)

                versions = list_version_ids(config, b, k)
                @test length(versions) == 1
                @test versions[1] == "null"
                @test read(S3Path(b, k; config, version=versions[1])) == b"original"

                s3_enable_versioning(config, b)
                @test versioning_enabled(config, b)

                # Overwrite the original object with a new version
                r2 = s3_put(config, b, k, "new and improved!"; parse_response=false)
                rv2 = HTTP.header(r2.headers, "x-amz-version-id", nothing)
                @test !isnothing(rv2)

                versions = list_version_ids(config, b, k)
                @test length(versions) == 2
                @test versions[1] == "null"
                @test versions[2] != "null"
                @test versions[2] == rv2
                @test read(S3Path(b, k; config, version=versions[1])) == b"original"
                @test read(S3Path(b, k; config, version=versions[2])) ==
                    b"new and improved!"
            finally
                AWSS3.s3_nuke_bucket(config, b)
            end
        end
    end

    # <https://github.com/JuliaCloud/AWSS3.jl/issues/168>
    @testset "Default `S3Path` does not freeze config" begin
        path = S3Path("s3://$(bucket_name)/test_str.txt")
        @test path.config === nothing
        @test AWSS3.get_config(path) !== nothing
    end

    @testset "No-op constructor" begin
        path = S3Path("s3://$(bucket_name)/test_str.txt")
        path2 = S3Path(path)
        @test path == path2
    end

    # MinIO does not care about regions, so this test doesn't work there
    if is_aws(base_config)
        @testset "Global config is not frozen at construction time" begin
            config = assume_testset_role("ReadWriteObject"; base_config)

            with_aws_config(config) do
                # Setup: create a file holding a string `abc`
                path = S3Path("s3://$(bucket_name)/test_str.txt")
                write(path, "abc")
                @test read(path, String) == "abc"  # Have access to read file

                alt_region = config.region == "us-east-2" ? "us-east-1" : "us-east-2"
                alt_config = AWSConfig(; region=alt_region) # this is the wrong region!

                with_aws_config(alt_config) do
                    @test_throws AWS.AWSException read(path, String)
                end

                # Now it works, without recreating `path`
                @test read(path, String) == "abc"
                rm(path)
            end
        end
    end

    # Broken on MinIO
    if is_aws(base_config)
        config = assume_testset_role("NukeBucket"; base_config)
        AWSS3.s3_nuke_bucket(config, bucket_name)
    end
end

using AWS
using AWS.AWSExceptions: AWSException
using AWSS3
using Arrow
using Dates
using FilePathsBase
using FilePathsBase: /, join
using FilePathsBase.TestPaths
using FilePathsBase.TestPaths: test
using HTTP
using JSON3
using Minio
using Mocking
using OrderedCollections: LittleDict
using Retry
using Test
using UUIDs: uuid4

Mocking.activate()

@service S3 use_response_type = true

include("utils.jl")

# Load the test functions
include("s3path.jl") # creates `awss3_tests(config)`
include("awss3.jl") # creates `s3path_tests(config)`

@testset "AWSS3.jl" begin
    # We can run most tests locally under MinIO without requring AWS credentials
    @testset "Minio" begin
        minio_server() do config
            awss3_tests(config)
            s3path_tests(config)
        end
    end

    @testset "S3" begin
        config = AWSConfig()
        awss3_tests(config)
        s3path_tests(config)
    end
end

using Test: @test, @test_throws, contains_warn

const BUCKET_DATE_FORMAT = dateformat"yyyymmdd\THHMMSS\Z"

is_aws(config) = config isa AWSConfig
AWS.aws_account_number(::Minio.MinioConfig) = "123"

function minio_server(body, dirs=[mktempdir()]; address="localhost:9005")
    server = Minio.Server(dirs; address)

    try
        run(server; wait=false)
        sleep(0.5)  # give the server just a bit of time, though it is amazingly fast to start

        config = MinioConfig(
            "http://$address"; username="minioadmin", password="minioadmin"
        )
        body(config)
    finally
        # Make sure we kill the server even if a test failed.
        kill(server)
    end
end

function gen_bucket_name(prefix="awss3.jl.test.")
    # # https://docs.aws.amazon.com/AmazonS3/latest/userguide/bucketnamingrules.html
    return lowercase(prefix * Dates.format(now(Dates.UTC), BUCKET_DATE_FORMAT))
end

function assume_role(aws_config::AbstractAWSConfig, role; duration=nothing)
    if startswith(role, "arn:aws:iam")
        role_arn = role
        role_name = basename(role)
    else
        response = AWSServices.sts(
            "GetCallerIdentity";
            aws_config,
            feature_set=AWS.FeatureSet(; use_response_type=true),
        )
        account_id = parse(response)["GetCallerIdentityResult"]["Account"]
        role_name = role
        role_arn = "arn:aws:iam::$account_id:role/$role_name"
    end

    role_session = AWS._role_session_name(
        "AWS.jl-role-",
        role_name,
        "-" * Dates.format(now(UTC), dateformat"yyyymmdd\THHMMSS\Z"),
    )
    params = Dict{String,Any}("RoleArn" => role_arn, "RoleSessionName" => role_session)
    if duration !== nothing
        params["DurationSeconds"] = duration
    end

    response = AWSServices.sts(
        "AssumeRole",
        params;
        aws_config,
        feature_set=AWS.FeatureSet(; use_response_type=true),
    )
    dict = parse(response)
    role_creds = dict["AssumeRoleResult"]["Credentials"]
    role_user = dict["AssumeRoleResult"]["AssumedRoleUser"]
    return AWSConfig(;
        creds=AWSCredentials(
            role_creds["AccessKeyId"],
            role_creds["SecretAccessKey"],
            role_creds["SessionToken"],
            role_user["Arn"];
            expiry=DateTime(rstrip(role_creds["Expiration"], 'Z')),
            renew=() -> assume_role(aws_config, role_arn; duration, mfa_serial).credentials,
        ),
    )
end

# TODO: We're ignoring assume role calls when using a `MinioConfig` as we don't yet support
# this.
function assume_role(config::MinioConfig, role; kwargs...)
    return config
end

function assume_testset_role(role_suffix; base_config)
    return assume_role(base_config, "AWSS3.jl-$role_suffix")
end

function with_aws_config(f, config::AbstractAWSConfig)
    local result
    old_config = global_aws_config()
    global_aws_config(config)
    try
        result = f()
    finally
        global_aws_config(old_config)
    end
    return result
end

# Rudementary support for `@test_throws ["Try", "Complex"] sqrt(-1)` for Julia 1.6
macro test_throws_msg(extype, ex)
    # https://github.com/JuliaLang/julia/pull/41888
    expr = if VERSION >= v"1.8.0-DEV.363"
        :(@test_throws $extype $ex)
    else
        quote
            @test try
                $ex
                false
            catch e
                exc = sprint(showerror, e)
                contains_warn(exc, $extype)
            end
        end
    end
    return esc(expr)
end

using AWSS3
using Documenter

DocMeta.setdocmeta!(AWSS3, :DocTestSetup, :(using AWSS3); recursive=true)

makedocs(;
    modules=[AWSS3],
    sitename="AWSS3.jl",
    format=Documenter.HTML(;
        canonical="https://juliacloud.github.io/AWSS3.jl/stable/", edit_link="main"
    ),
    pages=["Home" => "index.md", "API" => "api.md"],
)

deploydocs(; repo="github.com/JuliaCloud/AWSS3.jl.git", push_preview=true)

function awss3_tests(base_config)
    bucket_name = gen_bucket_name()

    @testset "Robust key selection" begin
        lower_dict = Dict("foo-bar" => 1)
        upper_dict = Dict("Foo-Bar" => 1)
        # HTTP.jl 2.x canonicalizes header names, so the stored key may match neither
        # the lowercase nor the requested spelling (e.g. `ETag` is stored as `Etag`).
        canonical_dict = Dict("Etag" => 1)
        @test AWSS3.get_robust_case(lower_dict, "Foo-Bar") == 1
        @test AWSS3.get_robust_case(upper_dict, "Foo-Bar") == 1
        @test AWSS3.get_robust_case(canonical_dict, "ETag") == 1
        @test_throws KeyError("Foo-Bar") AWSS3.get_robust_case(Dict(), "Foo-Bar")
    end

    @testset "Create Bucket" begin
        config = assume_testset_role("CreateBucketTestset"; base_config)
        s3_create_bucket(config, bucket_name)
        @test bucket_name in s3_list_buckets(config)
        is_aws(config) && s3_enable_versioning(config, bucket_name)
        sleep(1)
    end

    @testset "Bucket Tagging" begin
        config = assume_testset_role("BucketTaggingTestset"; base_config)
        @test isempty(s3_get_tags(config, bucket_name))
        tags = Dict("A" => "1", "B" => "2", "C" => "3")
        s3_put_tags(config, bucket_name, tags)
        @test s3_get_tags(config, bucket_name) == tags
        s3_delete_tags(config, bucket_name)
        @test isempty(s3_get_tags(config, bucket_name))
    end

    @testset "Create Objects" begin
        config = assume_testset_role("CreateObjectsTestset"; base_config)
        global_aws_config(config)

        s3_put(config, bucket_name, "key1", "data1.v1")
        s3_put(bucket_name, "key2", "data2.v1"; tags=Dict("Key" => "Value"))
        s3_put(config, bucket_name, "key3", "data3.v1")
        s3_put(config, bucket_name, "key3", "data3.v2")
        s3_put(config, bucket_name, "key3", "data3.v3"; metadata=Dict("foo" => "bar"))
        s3_put(config, bucket_name, "key4", "data3.v4"; acl="bucket-owner-full-control")
        s3_put_tags(config, bucket_name, "key3", Dict("Left" => "Right"))

        @test isempty(s3_get_tags(config, bucket_name, "key1"))
        @test s3_get_tags(config, bucket_name, "key2")["Key"] == "Value"
        @test s3_get_tags(config, bucket_name, "key3")["Left"] == "Right"
        s3_delete_tags(config, bucket_name, "key2")
        @test isempty(s3_get_tags(config, bucket_name, "key2"))

        @test s3_get(config, bucket_name, "key1") == b"data1.v1"
        @test s3_get(config, bucket_name, "key2") == b"data2.v1"
        @test s3_get(bucket_name, "key3") == b"data3.v3"
        @test s3_get(bucket_name, "key4") == b"data3.v4"

        try
            s3_get(config, bucket_name, "key5")
            @test false
        catch e
            e isa AWSException || rethrow()

            # Will see a 403 status if we lack the `s3:ListBucket` permission.
            @test e.cause.status == 404
        end

        # `s3_get_meta` returns the response headers verbatim, and HTTP.jl 2.x
        # canonicalizes header names (`x-amz-meta-foo` becomes `X-Amz-Meta-Foo`), so
        # look the key up case-insensitively.
        meta = s3_get_meta(bucket_name, "key3")
        @test AWSS3.get_robust_case(meta, "x-amz-meta-foo") == "bar"

        @test isa(
            s3_put(config, bucket_name, "key6", "data"; parse_response=false), AWS.Response
        )
    end

    @testset "ASync Get" begin
        config = assume_testset_role("ReadObject"; base_config)
        @sync begin
            for i in 1:2
                @async begin
                    @test s3_get(bucket_name, "key3") == b"data3.v3"
                end
            end
        end
    end

    @testset "Raw Return - XML" begin
        config = assume_testset_role("ReadWriteObject"; base_config)
        xml = "<?xml version='1.0'?><Doc><Text>Hello</Text></Doc>"
        @test s3_put(config, bucket_name, "file.xml", xml, "text/xml") == UInt8[]
        @test String(s3_get(config, bucket_name, "file.xml"; raw=true)) == xml
        @test s3_get(config, bucket_name, "file.xml")["Text"] == "Hello"
    end

    @testset "Get byte range" begin
        config = assume_testset_role("ReadWriteObject"; base_config)
        teststr = "123456789"
        s3_put(config, bucket_name, "byte_range", teststr)
        range = 3:6
        @test String(s3_get(config, bucket_name, "byte_range"; byte_range=range)) ==
            teststr[range]
    end

    @testset "Object Copy" begin
        config = assume_testset_role("ReadWriteObject"; base_config)
        result = s3_copy(
            config, bucket_name, "key1"; to_bucket=bucket_name, to_path="key1.copy"
        )
        @test result isa AbstractDict
        @test s3_get(config, bucket_name, "key1.copy") == b"data1.v1"

        result = s3_copy(
            config,
            bucket_name,
            "key1";
            to_bucket=bucket_name,
            to_path="key1.copy",
            parse_response=false,
        )
        @test result isa AWS.Response

        if is_aws(base_config)
            @test !isnothing(HTTP.header(result.headers, "x-amz-version-id", nothing))
        end
    end

    @testset "Object exists" begin
        config = assume_testset_role("ReadObject"; base_config)
        for key in ["key1", "key2", "key3", "key1.copy"]
            @test s3_exists(config, bucket_name, key)
        end
    end

    @testset "List Objects" begin
        config = assume_testset_role("ReadObject"; base_config)
        for key in ["key1", "key2", "key3", "key1.copy"]
            @test key in [o["Key"] for o in s3_list_objects(config, bucket_name)]
        end
    end

    @testset "Object Delete" begin
        config = assume_testset_role("ReadWriteObject"; base_config)
        s3_delete(config, bucket_name, "key1.copy")
        @test !("key1.copy" in [o["Key"] for o in s3_list_objects(config, bucket_name)])
    end

    @testset "Check Metadata" begin
        config = assume_testset_role("ReadObject"; base_config)
        meta = s3_get_meta(config, bucket_name, "key1")
        # HTTP.jl 2.x canonicalizes `ETag` to `Etag`
        @test AWSS3.get_robust_case(meta, "ETag") == "\"68bc8898af64159b72f349b391a7ae35\""
    end

    # https://github.com/samoconnor/AWSS3.jl/issues/24
    @testset "default Content-Type" begin
        config = assume_testset_role("ReadWriteObject"; base_config)
        ctype(key) = s3_get_meta(config, bucket_name, key)["Content-Type"]

        for k in ["file.foo", "file", "file_html", "file.d/html", "foobar.html/file.htm"]
            is_aws(config) && k == "file" && continue
            s3_put(config, bucket_name, k, "x")
            @test ctype(k) == "application/octet-stream"
        end

        for (k, t) in [
            ("foo/bar/file.html", "text/html"),
            ("x.y.z.js", "application/javascript"),
            ("downalods/foo.pdf", "application/pdf"),
            ("data/foo.csv", "text/csv"),
            ("this.is.a.file.txt", "text/plain"),
            ("my.log", "text/plain"),
            ("big.dat", "application/octet-stream"),
            ("some.tar.gz", "application/octet-stream"),
            ("data.bz2", "application/octet-stream"),
        ]
            s3_put(config, bucket_name, k, "x")
            @test ctype(k) == t
        end
    end

    @testset "Multi-Part Upload" begin
        config = assume_testset_role("MultipartUploadTestset"; base_config)
        MIN_S3_CHUNK_SIZE = 5 * 1024 * 1024 # 5 MB
        key_name = "multi-part-key"
        upload = s3_begin_multipart_upload(config, bucket_name, key_name)
        tags = Vector{String}()

        for part_number in 1:5
            push!(
                tags,
                s3_upload_part(config, upload, part_number, rand(UInt8, MIN_S3_CHUNK_SIZE)),
            )
        end

        result = s3_complete_multipart_upload(config, upload, tags)
        @test s3_exists(config, bucket_name, key_name)
        @test isa(result, LittleDict)
    end

    @testset "Multi-Part Upload, return unparsed path" begin
        config = assume_testset_role("MultipartUploadTestset"; base_config)
        MIN_S3_CHUNK_SIZE = 5 * 1024 * 1024 # 5 MB
        key_name = "multi-part-key"
        upload = s3_begin_multipart_upload(config, bucket_name, key_name)
        tags = Vector{String}()

        for part_number in 1:5
            push!(
                tags,
                s3_upload_part(config, upload, part_number, rand(UInt8, MIN_S3_CHUNK_SIZE)),
            )
        end

        result = s3_complete_multipart_upload(config, upload, tags; parse_response=false)
        @test s3_exists(config, bucket_name, key_name)
        @test isa(result, AWS.Response)
    end

    # these tests are needed because lack of functionality of the underlying AWS API makes certain
    # seemingly inane tasks incredibly tricky: for example checking if an "object" (file or
    # directory) exists is very subtle
    @testset "path naming edge cases" begin
        config = assume_testset_role("ReadWriteObject"; base_config)

        # this seemingly arbitrary operation is needed because of the insanely tricky way we
        # need to check for directories
        s3_put(config, bucket_name, "testdir.", "") # create an empty file called `testdir.`
        s3_put(config, bucket_name, "testdir/", "") # create an empty file called `testdir/` which AWS will treat as an "empty directory"
        @test s3_exists(config, bucket_name, "testdir/")
        @test isdir(S3Path(bucket_name, "testdir/"; config))
        @test !isfile(S3Path(bucket_name, "testdir/"; config))
        @test s3_exists(config, bucket_name, "testdir.")
        @test isfile(S3Path(bucket_name, "testdir."; config))
        @test !isdir(S3Path(bucket_name, "testdir."; config))
        @test !s3_exists(config, bucket_name, "testdir")

        s3_put(config, bucket_name, "testdir/testfile.txt", "what up")
        @test s3_exists(config, bucket_name, "testdir/testfile.txt")
        @test isfile(S3Path(bucket_name, "testdir/testfile.txt"; config))
        # make sure the directory still "exists" even though there's a key in there now
        @test s3_exists(config, bucket_name, "testdir/")
        @test isdir(S3Path(bucket_name, "testdir/"; config))
        @test !isfile(S3Path(bucket_name, "testdir/"; config))

        # but it is still a directory and not an object
        @test !s3_exists(config, bucket_name, "testdir")
    end

    # Based upon this example: https://repost.aws/knowledge-center/iam-s3-user-specific-folder
    #
    # MinIO isn't currently setup with the restrictive prefix required to make the tests
    # fail with "AccessDenied".
    is_aws(base_config) && @testset "Restricted Prefix" begin
        setup_config = assume_testset_role("ReadWriteObject"; base_config)
        s3_put(
            setup_config,
            bucket_name,
            "prefix/denied/secrets/top-secret",
            "for british eyes only",
        )
        s3_put(setup_config, bucket_name, "prefix/granted/file", "hello")

        config = assume_testset_role("RestrictedPrefixTestset"; base_config)
        @test s3_exists(config, bucket_name, "prefix/granted/file")
        @test !s3_exists(config, bucket_name, "prefix/granted/dne")
        @test_throws_msg ["AccessDenied", "403"] begin
            s3_exists(config, bucket_name, "prefix/denied/top-secret")
        end
        @test s3_exists(config, bucket_name, "prefix/granted/")
        @test s3_exists(config, bucket_name, "prefix/")

        # Ensure that `s3_list_objects` works with restricted prefixes
        @test length(collect(s3_list_objects(config, bucket_name, "prefix/granted/"))) == 1
        @test length(collect(s3_list_objects(config, bucket_name, "prefix/"))) == 0

        # Validate that we have permissions to list the root without encountering an access error.
        # Ideally we just want `@test_no_throws s3_list_objects(config, bucket_name)`.
        @test length(collect(s3_list_objects(config, bucket_name))) >= 0
    end

    @testset "Version is empty" begin
        config = assume_testset_role("ReadWriteObject"; base_config)

        # Create the file to ensure we're only testing `version`
        k = "version_empty.txt"
        s3_put(config, bucket_name, k, "v1")
        s3_put(config, bucket_name, k, "v2")

        if is_aws(config)
            @test_throws AWSException s3_get(config, bucket_name, k; version="")
            @test_throws AWSException s3_get_meta(config, bucket_name, k; version="")
            @test_throws AWSException s3_exists(config, bucket_name, k; version="")
            @test_throws AWSException s3_delete(config, bucket_name, k; version="")
        else
            # Using an empty string as the version returns the latest version
            @test s3_get(config, bucket_name, k; version="") == "v2"
            @test s3_get_meta(config, bucket_name, k; version="") isa AbstractDict
            @test s3_exists(config, bucket_name, k; version="")
            @test s3_delete(config, bucket_name, k; version="") == UInt8[]
        end
    end

    @testset "Version is nothing" begin
        config = assume_testset_role("ReadWriteObject"; base_config)

        # Create the file to ensure we're only testing `version`
        k = "version_nothing.txt"
        s3_put(config, bucket_name, k, "v1")
        s3_put(config, bucket_name, k, "v2")

        # Using an empty string as the version returns the latest version
        @test s3_get(config, bucket_name, k; version=nothing) == "v2"
        @test s3_get_meta(config, bucket_name, k; version=nothing) isa AbstractDict
        @test s3_exists(config, bucket_name, k; version=nothing)
        @test s3_delete(config, bucket_name, k; version=nothing) == UInt8[]
    end

    is_aws(base_config) && @testset "Sign URL" begin
        config = assume_testset_role("SignUrlTestset"; base_config)
        for v in ["v2", "v4"]
            url = s3_sign_url(config, bucket_name, "key1"; signature_version=v)
            curl_output = ""

            @repeat 3 try
                curl_output = read(`curl -s -o - $url`, String)
            catch e
                @delay_retry if true
                end
            end

            @test curl_output == "data1.v1"

            fn = "/tmp/jl_qws_test_key1"
            if isfile(fn)
                rm(fn)
            end

            @repeat 3 try
                s3_get_file(config, bucket_name, "key1", fn)
            catch e
                sleep(1)
                @retry if true
                end
            end

            @test read(fn, String) == "data1.v1"
            rm(fn)
        end
    end

    is_aws(base_config) && @testset "Check Object Versions" begin
        config = assume_testset_role("ReadObjectVersion"; base_config)
        versions = s3_list_versions(config, bucket_name, "key3")
        @test length(versions) == 3
        @test (
            s3_get(config, bucket_name, "key3"; version=versions[3]["VersionId"]) ==
            b"data3.v1"
        )
        @test (
            s3_get(config, bucket_name, "key3"; version=versions[2]["VersionId"]) ==
            b"data3.v2"
        )
        @test (
            s3_get(config, bucket_name, "key3"; version=versions[1]["VersionId"]) ==
            b"data3.v3"
        )

        tmp_file = joinpath(tempdir(), "jl_qws_test_key3")
        s3_get_file(config, bucket_name, "key3", tmp_file; version=versions[2]["VersionId"])
        @test read(tmp_file) == b"data3.v2"
    end

    is_aws(base_config) && @testset "Purge Versions" begin
        config = assume_testset_role("PurgeVersionsTestset"; base_config)
        s3_purge_versions(config, bucket_name, "key3")
        versions = s3_list_versions(config, bucket_name, "key3")
        @test length(versions) == 1
        @test s3_get(config, bucket_name, "key3") == b"data3.v3"
    end

    is_aws(base_config) && @testset "Delete All Versions" begin
        config = assume_testset_role("NukeObjectTestset"; base_config)
        key_to_delete = "NukeObjectTestset_key"
        # Test that object that starts with the same prefix as `key_to_delete` is
        # not _also_ deleted
        key_not_to_delete = "NukeObjectTestset_key/rad"

        function _s3_object_versions(config, bucket, key)
            return filter!(x -> x["Key"] == key, s3_list_versions(config, bucket, key))
        end

        s3_put(config, bucket_name, key_to_delete, "foo.v1")
        s3_put(config, bucket_name, key_to_delete, "foo.v2")
        s3_put(config, bucket_name, key_to_delete, "foo.v3")
        s3_put(config, bucket_name, key_not_to_delete, "rad.v1")
        s3_put(config, bucket_name, key_not_to_delete, "rad.v2")

        @test length(_s3_object_versions(config, bucket_name, key_to_delete)) == 3
        @test length(_s3_object_versions(config, bucket_name, key_not_to_delete)) == 2

        s3_nuke_object(config, bucket_name, key_to_delete)
        @test length(_s3_object_versions(config, bucket_name, key_to_delete)) == 0

        # Test that _only_ specific path was deleted---not paths at the same prefix
        @test length(_s3_object_versions(config, bucket_name, key_not_to_delete)) == 2
    end

    if is_aws(base_config)
        @testset "Empty and Delete Bucket" begin
            config = assume_testset_role("EmptyAndDeleteBucketTestset"; base_config)
            AWSS3.s3_nuke_bucket(config, bucket_name)
            @test !in(bucket_name, s3_list_buckets(config))
        end

        @testset "Delete Non-Existent Bucket" begin
            config = assume_testset_role("DeleteNonExistentBucketTestset"; base_config)
            @test_throws AWS.AWSException s3_delete_bucket(config, bucket_name)
        end
    end
end

#==============================================================================#
# AWSS3.jl
#
# S3 API. See http://docs.aws.amazon.com/AmazonS3/latest/API/APIRest.html
#
# Copyright OC Technology Pty Ltd 2014 - All rights reserved
#==============================================================================#

module AWSS3

export S3Path,
    s3_arn,
    s3_put,
    s3_get,
    s3_get_file,
    s3_exists,
    s3_delete,
    s3_copy,
    s3_create_bucket,
    s3_put_cors,
    s3_enable_versioning,
    s3_delete_bucket,
    s3_list_buckets,
    s3_list_objects,
    s3_list_keys,
    s3_list_versions,
    s3_nuke_object,
    s3_get_meta,
    s3_directory_stat,
    s3_purge_versions,
    s3_sign_url,
    s3_begin_multipart_upload,
    s3_upload_part,
    s3_complete_multipart_upload,
    s3_multipart_upload,
    s3_get_tags,
    s3_put_tags,
    s3_delete_tags

using AWS
using AWS.AWSServices: s3
using ArrowTypes
using Base64
using Compat: @something
using Dates
using EzXML
using FilePathsBase
using FilePathsBase: /, join
using HTTP: HTTP
using Mocking
using OrderedCollections: OrderedDict, LittleDict
using Retry
using SymDict
using URIs
using UUIDs
using XMLDict

@service S3 use_response_type = true

const SSDict = Dict{String,String}
const AbstractS3Version = Union{AbstractString,Nothing}
const AbstractS3PathConfig = Union{AbstractAWSConfig,Nothing}

# Utility function to workaround https://github.com/JuliaCloud/AWS.jl/issues/547
function get_robust_case(x, key)
    lkey = lowercase(key)
    haskey(x, lkey) && return x[lkey]
    return x[key]
end

__init__() = FilePathsBase.register(S3Path)

# Declare new `parse` function to avoid type piracy
# TODO: remove when changes are released: https://github.com/JuliaCloud/AWS.jl/pull/502
function parse(r::AWS.Response, mime::MIME)
    # AWS doesn't always return a Content-Type which results the parsing returning bytes
    # instead of a dictionary. To address this we'll allow passing in the MIME type.
    return try
        AWS._rewind(r.io) do io
            AWS._read(io, mime)
        end
    catch e
        @warn "Failed to parse the following content as $mime:\n\"\"\"$(String(r.body))\"\"\""
        rethrow(e)
    end
end
parse(args...; kwargs...) = Base.parse(args...; kwargs...)

"""
    s3_arn(resource)
    s3_arn(bucket,path)

[Amazon Resource Name](http://docs.aws.amazon.com/general/latest/gr/aws-arns-and-namespaces.html)
for S3 `resource` or `bucket` and `path`.
"""
s3_arn(resource) = "arn:aws:s3:::$resource"
s3_arn(bucket, path) = s3_arn("$bucket/$path")

"""
    s3_get([::AbstractAWSConfig], bucket, path; <keyword arguments>)

Retrieves an object from the `bucket` for a given `path`.

# Optional Arguments
- `version=nothing`: version of object to get.
- `retry=true`: try again on "NoSuchBucket", "NoSuchKey" (common if object was recently
  created).
- `raw=false`:  return response as `Vector{UInt8}`
- `byte_range=nothing`:  given an iterator of `(start_byte, end_byte)` gets only
  the range of bytes of the object from `start_byte` to `end_byte`.  For example,
  `byte_range=1:4` gets bytes 1 to 4 inclusive.  Arguments should use the Julia convention
  of 1-based indexing.
- `header::Dict{String,String}`: pass in an HTTP header to the request.

As an example of how to set custom HTTP headers, the below is equivalent to
`s3_get(aws, bucket, path; byte_range=range)`:

```julia
s3_get(aws, bucket, path; headers=Dict{String,String}("Range" => "bytes=\$(first(range)-1)-\$(last(range)-1)"))
```

# API Calls

- [`GetObject`](https://docs.aws.amazon.com/AmazonS3/latest/API/API_GetObject.html)

# Permissions

- [`s3:GetObject`](https://docs.aws.amazon.com/service-authorization/latest/reference/list_amazons3.html#amazons3-GetObject):
  (conditional): required when `version === nothing`.
- [`s3:GetObjectVersion`](https://docs.aws.amazon.com/service-authorization/latest/reference/list_amazons3.html#amazons3-GetObjectVersion):
  (conditional): required when `version !== nothing`.
- [`s3:ListBucket`](https://docs.aws.amazon.com/service-authorization/latest/reference/list_amazons3.html#amazons3-ListBucket)
  (optional): allows requests to non-existent objects to throw a exception with HTTP status
  code 404 (Not Found) instead of HTTP status code 403 (Access Denied).
"""
function s3_get(
    aws::AbstractAWSConfig,
    bucket,
    path;
    version::AbstractS3Version=nothing,
    retry::Bool=true,
    raw::Bool=false,
    byte_range::Union{Nothing,AbstractVector}=nothing,
    headers::AbstractDict{<:AbstractString,<:Any}=Dict{String,Any}(),
    return_stream::Bool=false,
    kwargs...,
)
    @repeat 4 try
        params = Dict{String,Any}()
        return_stream && (params["response_stream"] = Base.BufferStream())
        if version !== nothing
            params["versionId"] = version
        end

        if byte_range !== nothing
            headers = copy(headers)  # make sure we don't mutate existing object
            # we make sure we stick to the Julia convention of 1-based indexing
            a, b = (first(byte_range) - 1), (last(byte_range) - 1)
            headers["Range"] = "bytes=$a-$b"
        end

        if !isempty(headers)
            params["headers"] = headers
        end

        r = S3.get_object(bucket, path, params; aws_config=aws, kwargs...)
        return if return_stream
            close(r.io)
            r.io
        elseif raw
            r.body
        else
            parse(r)
        end
    catch e
        #! format: off
        # https://github.com/domluna/JuliaFormatter.jl/issues/459
        @delay_retry if retry && ecode(e) in ["NoSuchBucket", "NoSuchKey"] end
        #! format: on
    end
end

s3_get(a...; b...) = s3_get(global_aws_config(), a...; b...)

"""
    s3_get_file([::AbstractAWSConfig], bucket, path, filename; [version=], kwargs...)

Like `s3_get` but streams result directly to `filename`.  Keyword arguments accept are
the same as those for `s3_get`.
"""
function s3_get_file(
    aws::AbstractAWSConfig,
    bucket,
    path,
    filename;
    version::AbstractS3Version=nothing,
    kwargs...,
)
    stream = s3_get(aws, bucket, path; version=version, return_stream=true, kwargs...)

    open(filename, "w") do file
        while !eof(stream)
            write(file, readavailable(stream))
        end
    end
end

s3_get_file(a...; b...) = s3_get_file(global_aws_config(), a...; b...)

function s3_get_file(
    aws::AbstractAWSConfig,
    buckets::Vector,
    path,
    filename;
    version::AbstractS3Version=nothing,
    kwargs...,
)
    i = start(buckets)

    @repeat length(buckets) try
        bucket, i = next(buckets, i)
        s3_get_file(aws, bucket, path, filename; version=version, kwargs...)
    catch e
        #! format: off
        @retry if ecode(e) in ["NoSuchKey", "AccessDenied"] end
        #! format: on
    end
end

"""
   s3_get_meta([::AbstractAWSConfig], bucket, path; [version], kwargs...)

Retrieves metadata from an object without returning the object itself.

# API Calls

- [`HeadObject`](https://docs.aws.amazon.com/AmazonS3/latest/API/API_HeadObject.html)

# Permissions

- [`s3:GetObject`](https://docs.aws.amazon.com/service-authorization/latest/reference/list_amazons3.html#amazons3-GetObject)
  (conditional): required when `version === nothing`.
- [`s3:GetObjectVersion`](https://docs.aws.amazon.com/service-authorization/latest/reference/list_amazons3.html#amazons3-GetObjectVersion):
  (conditional): required when `version !== nothing`.
- [`s3:ListBucket`](https://docs.aws.amazon.com/service-authorization/latest/reference/list_amazons3.html#amazons3-ListBucket)
  (optional): allows requests to non-existent objects to throw a exception with HTTP status
  code 404 (Not Found) instead of HTTP status code 403 (Access Denied).
"""
function s3_get_meta(
    aws::AbstractAWSConfig, bucket, path; version::AbstractS3Version=nothing, kwargs...
)
    params = Dict{String,Any}()
    if version !== nothing
        params["versionId"] = version
    end

    r = S3.head_object(bucket, path, params; aws_config=aws, kwargs...)
    return Dict(r.headers)
end

s3_get_meta(a...; b...) = s3_get_meta(global_aws_config(), a...; b...)

function _s3_exists_file(aws::AbstractAWSConfig, bucket, path)
    q = Dict("prefix" => path, "delimiter" => "/", "max-keys" => 1)
    l = parse(S3.list_objects_v2(bucket, q; aws_config=aws))
    c = get(l, "Contents", nothing)
    c === nothing && return false
    return get(c, "Key", "") == path
end

"""
    _s3_exists_dir(aws::AbstractAWSConfig, bucket, path)

An internal function used by [`s3_exists`](@ref).

Checks if the given directory exists within the `bucket`. Since S3 uses a flat structure, as
opposed to being hierarchical like a file system, directories are actually just a collection
of object keys which share a common prefix. S3 implements empty directories as
[0-byte objects](https://docs.aws.amazon.com/AmazonS3/latest/userguide/using-folders.html)
with keys ending with the delimiter.

It is possible to create non 0-byte objects with a key ending in the delimiter
(e.g. `s3_put(bucket, "abomination/", "If I cannot inspire love, I will cause fear!")`)
which the AWS console interprets as the directory "abmonination" containing the object "/".
"""
function _s3_exists_dir(aws::AbstractAWSConfig, bucket, path)
    endswith(path, '/') || throw(ArgumentError("S3 directories must end with '/': $path"))
    q = Dict("prefix" => path, "delimiter" => "/", "max-keys" => 1)
    r = parse(S3.list_objects_v2(bucket, q; aws_config=aws))
    return get(r, "KeyCount", "0") != "0"
end

"""
    s3_exists_versioned([::AbstractAWSConfig], bucket, path, version)

Returns if an object `version` exists with the key `path` in the `bucket`.

Note that the AWS API's support for object versioning is quite limited and this check will
involve `try`/`catch` logic. Prefer using [`s3_exists_unversioned `](@ref) where possible
for more performant checks.

See [`s3_exists`](@ref) and [`s3_exists_unversioned`](@ref).

# API Calls

- [`ListObjectV2`](https://docs.aws.amazon.com/AmazonS3/latest/API/API_ListObjectsV2.html)

# Permissions

- [`s3:GetObjectVersion`](https://docs.aws.amazon.com/service-authorization/latest/reference/list_amazons3.html#amazons3-GetObjectVersion)
- [`s3:ListBucket`](https://docs.aws.amazon.com/service-authorization/latest/reference/list_amazons3.html#amazons3-ListBucket)
  (optional): allows requests to non-existent objects to throw a exception with HTTP status
  code 404 (Not Found) instead of HTTP status code 403 (Access Denied).
"""
function s3_exists_versioned(
    aws::AbstractAWSConfig, bucket, path, version::AbstractS3Version
)
    @repeat 2 try
        s3_get_meta(aws, bucket, path; version=version)
        return true
    catch e
        #! format: off
        @delay_retry if ecode(e) in ["NoSuchBucket", "404", "NoSuchKey", "AccessDenied"] end
        #! format: on

        @ignore if ecode(e) in ["404", "NoSuchKey", "AccessDenied"]
            return false
        end
    end
end

"""
    s3_exists_unversioned([::AbstractAWSConfig], bucket, path)

Returns a boolean whether an object exists at  `path` in `bucket`.

See [`s3_exists`](@ref) and [`s3_exists_versioned`](@ref).

# API Calls

- [`ListObjectV2`](https://docs.aws.amazon.com/AmazonS3/latest/API/API_ListObjectsV2.html)

# Permissions

- [`s3:GetObject`](https://docs.aws.amazon.com/service-authorization/latest/reference/list_amazons3.html#amazons3-GetObjectVersion)
- [`s3:ListBucket`](https://docs.aws.amazon.com/service-authorization/latest/reference/list_amazons3.html#amazons3-ListBucket)
  (optional): allows requests to non-existent objects to throw a exception with HTTP status
  code 404 (Not Found) instead of HTTP status code 403 (Access Denied).
"""
function s3_exists_unversioned(aws::AbstractAWSConfig, bucket, path)
    f = endswith(path, '/') ? _s3_exists_dir : _s3_exists_file
    return f(aws, bucket, path)
end

"""
    s3_exists([::AbstractAWSConfig], bucket, path; version=nothing)

Returns if an object exists with the key `path` in the `bucket`. If a `version` is specified
then an object must exist with the specified version identifier.

Note that the AWS API's support for object versioning is quite limited and this check will
involve `try`/`catch` logic if a `version` is specified.

# API Calls

- [`ListObjectV2`](https://docs.aws.amazon.com/AmazonS3/latest/API/API_ListObjectsV2.html)

# Permissions

- [`s3:GetObject`](https://docs.aws.amazon.com/service-authorization/latest/reference/list_amazons3.html#amazons3-GetObject)
  (conditional): required when `version === nothing`.
- [`s3:GetObjectVersion`](https://docs.aws.amazon.com/service-authorization/latest/reference/list_amazons3.html#amazons3-GetObjectVersion):
  (conditional): required when `version !== nothing`.
- [`s3:ListBucket`](https://docs.aws.amazon.com/service-authorization/latest/reference/list_amazons3.html#amazons3-ListBucket)
  (optional): allows requests to non-existent objects to throw a exception with HTTP status
  code 404 (Not Found) instead of HTTP status code 403 (Access Denied).
"""
function s3_exists(aws::AbstractAWSConfig, bucket, path; version::AbstractS3Version=nothing)
    if version !== nothing
        s3_exists_versioned(aws, bucket, path, version)
    else
        s3_exists_unversioned(aws, bucket, path)
    end
end
s3_exists(a...; b...) = s3_exists(global_aws_config(), a...; b...)

"""
    s3_delete([::AbstractAWSConfig], bucket, path; [version], kwargs...)

Deletes an object from a bucket. The `version` argument can be used to delete a specific
version.

# API Calls

- [`DeleteObject`](https://docs.aws.amazon.com/AmazonS3/latest/API/API_DeleteObject.html)

# Permissions

- [`s3:DeleteObject`](https://docs.aws.amazon.com/service-authorization/latest/reference/list_amazons3.html#amazons3-DeleteObject)
"""
function s3_delete(
    aws::AbstractAWSConfig, bucket, path; version::AbstractS3Version=nothing, kwargs...
)
    params = Dict{String,Any}()
    if version !== nothing
        params["versionId"] = version
    end

    return parse(S3.delete_object(bucket, path, params; aws_config=aws, kwargs...))
end

s3_delete(a...; b...) = s3_delete(global_aws_config(), a...; b...)

"""
    s3_nuke_object([::AbstractAWSConfig], bucket, path; kwargs...)

Deletes all versions of object `path` from `bucket`. All provided `kwargs` are forwarded to
[`s3_delete`](@ref). In the event an error occurs any object versions already deleted by
`s3_nuke_object` will be lost.

To only delete one specific version, use [`s3_delete`](@ref); to delete all versions
EXCEPT the latest version, use [`s3_purge_versions`](@ref); to delete all versions
in an entire bucket, use [`AWSS3.s3_nuke_bucket`](@ref).

# API Calls

- [`DeleteObject`](https://docs.aws.amazon.com/AmazonS3/latest/API/API_DeleteObject.html)
- [`ListObjectVersions`](https://docs.aws.amazon.com/AmazonS3/latest/API/API_ListObjectVersions.html)

# Permissions

- [`s3:DeleteObject`](https://docs.aws.amazon.com/service-authorization/latest/reference/list_amazons3.html#amazons3-DeleteObject)
- [`s3:ListBucketVersions`](https://docs.aws.amazon.com/service-authorization/latest/reference/list_amazons3.html#amazons3-ListBucketVersions)
"""
function s3_nuke_object(aws::AbstractAWSConfig, bucket, path; kwargs...)
    # Because list_versions returns ALL keys with the given _prefix_, we need to
    # restrict the results to ones with the _exact same_ key.
    for object in s3_list_versions(aws, bucket, path)
        object["Key"] == path || continue
        version = object["VersionId"]
        try
            s3_delete(aws, bucket, path; version, kwargs...)
        catch e
            @warn "Failed to delete version $(version) of $(path)"
            rethrow(e)
        end
    end
    return nothing
end

function s3_nuke_object(bucket, path; kwargs...)
    return s3_nuke_object(global_aws_config(), bucket, path; kwargs...)
end

"""
    s3_copy([::AbstractAWSConfig], bucket, path; acl::AbstractString="",
            to_bucket=bucket, to_path=path, metadata::AbstractDict=SSDict(),
            parse_response::Bool=true, kwargs...)

Copy the object at `path` in `bucket` to `to_path` in `to_bucket`.

# Optional Arguments
- `acl=`; `x-amz-acl` header for setting access permissions with canned config.
    See [here](https://docs.aws.amazon.com/AmazonS3/latest/dev/acl-overview.html#canned-acl).
- `metadata::Dict=`; `x-amz-meta-` headers.
- `parse_response::Bool=`; when `false`, return raw `AWS.Response`
- `kwargs`; additional kwargs passed through into `S3.copy_object`

# API Calls

- [`CopyObject`](http://https://docs.aws.amazon.com/AmazonS3/latest/API/API_CopyObject.html)

# Permissions

- [`s3:PutObject`](https://docs.aws.amazon.com/service-authorization/latest/reference/list_amazons3.html#amazons3-PutObject)
- [`s3:GetObject`](https://docs.aws.amazon.com/service-authorization/latest/reference/list_amazons3.html#amazons3-GetObject)
"""
function s3_copy(
    aws::AbstractAWSConfig,
    bucket,
    path;
    acl::AbstractString="",
    to_bucket=bucket,
    to_path=path,
    metadata::AbstractDict=SSDict(),
    parse_response::Bool=true,
    kwargs...,
)
    headers = SSDict(
        "x-amz-metadata-directive" => "REPLACE",
        Pair["x-amz-meta-$k" => v for (k, v) in metadata]...,
    )

    if !isempty(acl)
        headers["x-amz-acl"] = acl
    end

    response = S3.copy_object(
        to_bucket,
        to_path,
        "$bucket/$path",
        Dict("headers" => headers);
        aws_config=aws,
        kwargs...,
    )
    return parse_response ? parse(response) : response
end

s3_copy(a...; b...) = s3_copy(global_aws_config(), a...; b...)

"""
    s3_create_bucket([::AbstractAWSConfig], bucket; kwargs...)

Creates a new S3 bucket with the globally unique `bucket` name. The bucket will be created
AWS region associated with the `AbstractAWSConfig` (defaults to "us-east-1").

# API Calls

- [`CreateBucket`](https://docs.aws.amazon.com/AmazonS3/latest/API/API_CreateBucket.html)

# Permissions

- [`s3:CreateBucket`](https://docs.aws.amazon.com/service-authorization/latest/reference/list_amazons3.html#amazons3-CreateBucket)
"""
function s3_create_bucket(aws::AbstractAWSConfig, bucket; kwargs...)
    r = @protected try
        if aws.region == "us-east-1"
            S3.create_bucket(bucket; aws_config=aws, kwargs...)
        else
            bucket_config = """
                <CreateBucketConfiguration xmlns="http://s3.amazonaws.com/doc/2006-03-01/">
                    <LocationConstraint>$(aws.region)</LocationConstraint>
                </CreateBucketConfiguration>
                """

            S3.create_bucket(
                bucket,
                Dict("CreateBucketConfiguration" => bucket_config);
                aws_config=aws,
                kwargs...,
            )
        end
    catch e
        #! format: off
        @ignore if ecode(e) == "BucketAlreadyOwnedByYou" end
        #! format: on
    end
    return parse(r)
end

s3_create_bucket(a) = s3_create_bucket(global_aws_config(), a)

"""
    s3_put_cors([::AbstractAWSConfig], bucket, cors_config; kwargs...)

[PUT Bucket cors](http://docs.aws.amazon.com/AmazonS3/latest/API/RESTBucketPUTcors.html)

```
s3_put_cors("my_bucket", \"\"\"
    <?xml version="1.0" encoding="UTF-8"?>
    <CORSConfiguration xmlns="http://s3.amazonaws.com/doc/2006-03-01/">
        <CORSRule>
            <AllowedOrigin>http://my.domain.com</AllowedOrigin>
            <AllowedOrigin>http://my.other.domain.com</AllowedOrigin>
            <AllowedMethod>GET</AllowedMethod>
            <AllowedMethod>HEAD</AllowedMethod>
            <AllowedHeader>*</AllowedHeader>
            <ExposeHeader>Content-Range</ExposeHeader>
        </CORSRule>
    </CORSConfiguration>
\"\"\"
```
"""
function s3_put_cors(aws::AbstractAWSConfig, bucket, cors_config; kwargs...)
    return parse(S3.put_bucket_cors(bucket, cors_config; aws_config=aws, kwargs...))
end

s3_put_cors(a...; b...) = s3_put_cors(AWS.global_aws_config(), a...; b...)

"""
    s3_enable_versioning([::AbstractAWSConfig], bucket, [status]; kwargs...)

Enables or disables versioning for all objects within the given `bucket`. Use `status` to
either enable or disable versioning (respectively "Enabled" and "Suspended").

# API Calls

- [`PutBucketVersioning`](https://docs.aws.amazon.com/AmazonS3/latest/API/API_PutBucketVersioning.html)

# Permissions

- [`s3:PutBucketVersioning`](https://docs.aws.amazon.com/service-authorization/latest/reference/list_amazons3.html#amazons3-PutBucketVersioning)
"""
function s3_enable_versioning(aws::AbstractAWSConfig, bucket, status="Enabled"; kwargs...)
    versioning_config = """
        <VersioningConfiguration xmlns="http://s3.amazonaws.com/doc/2006-03-01/">
            <Status>$status</Status>
        </VersioningConfiguration>
        """

    r = s3(
        "PUT",
        "/$(bucket)?versioning",
        Dict("body" => versioning_config);
        aws_config=aws,
        feature_set=AWS.FeatureSet(; use_response_type=true),
        kwargs...,
    )
    return parse(r)
end

s3_enable_versioning(a; b...) = s3_enable_versioning(global_aws_config(), a; b...)

"""
    s3_put_tags([::AbstractAWSConfig], bucket, [path], tags::Dict; kwargs...)

Sets the tags for a bucket or an existing object. When `path` is specified then tagging
is performed on the object, otherwise it is performed on the `bucket`.

See also [`s3_put_tags`](@ref), [`s3_delete_tags`](@ref), and [`s3_put`'s](@ref) `tag`
option.

# API Calls

- [`PutBucketTagging`](https://docs.aws.amazon.com/AmazonS3/latest/API/API_PutBucketTagging.html)(conditional): used when `path` is not specified (bucket tagging).
- [`PutObjectTagging`](https://docs.aws.amazon.com/AmazonS3/latest/API/API_PutObjectTagging.html) (conditional): used when `path` is specified (object tagging).

# Permissions

- [`s3:PutBucketTagging`](https://docs.aws.amazon.com/service-authorization/latest/reference/list_amazons3.html#amazons3-PutBucketTagging)
  (conditional): required for when `path` is not specified (bucket tagging).
- [`s3:PutObjectTagging`](https://docs.aws.amazon.com/service-authorization/latest/reference/list_amazons3.html#amazons3-PutObjectTagging)
  (conditional): required when `path` is specified (object tagging).
"""
function s3_put_tags(aws::AbstractAWSConfig, bucket, path, tags::SSDict; kwargs...)
    tag_set = Dict("Tag" => [Dict("Key" => k, "Value" => v) for (k, v) in tags])
    tags = Dict("Tagging" => Dict("TagSet" => tag_set))

    tags = XMLDict.node_xml(tags)

    uri_path = isempty(path) ? "/$(bucket)?tagging" : "/$(bucket)/$(path)?tagging"

    r = s3(
        "PUT",
        uri_path,
        Dict("body" => tags);
        feature_set=AWS.FeatureSet(; use_response_type=true),
        aws_config=aws,
        kwargs...,
    )
    return parse(r)
end

function s3_put_tags(aws::AbstractAWSConfig, bucket, tags::SSDict; kwargs...)
    return s3_put_tags(aws, bucket, "", tags; kwargs...)
end

s3_put_tags(a...) = s3_put_tags(global_aws_config(), a...)

"""
    s3_get_tags([::AbstractAWSConfig], bucket, [path]; kwargs...)

Get the tags associated with a bucket or an existing object. When `path` is specified then
tag retrieval is performed on the object, otherwise it is performed on the `bucket`.

See also [`s3_put_tags`](@ref) and [`s3_delete_tags`](@ref).

# API Calls

- [`GetBucketTagging`](https://docs.aws.amazon.com/AmazonS3/latest/API/API_GetBucketTagging.html)  (conditional): used when `path` is not specified (bucket tagging).
- [`GetObjectTagging`](https://docs.aws.amazon.com/AmazonS3/latest/API/API_GetObjectTagging.html) (conditional): used when `path` is specified (object tagging).

# Permissions

- [`s3:GetBucketTagging`](https://docs.aws.amazon.com/service-authorization/latest/reference/list_amazons3.html#amazons3-GetBucketTagging)
  (conditional): required for when `path` is not specified (bucket tagging).
- [`s3:GetObjectTagging`](https://docs.aws.amazon.com/service-authorization/latest/reference/list_amazons3.html#amazons3-GetObjectTagging)
  (conditional): required when `path` is specified (object tagging).
"""
function s3_get_tags(aws::AbstractAWSConfig, bucket, path=""; kwargs...)
    @protected try
        tags = []

        r = if isempty(path)
            S3.get_bucket_tagging(bucket; aws_config=aws, kwargs...)
        else
            S3.get_object_tagging(bucket, path; aws_config=aws, kwargs...)
        end
        tags = parse(r, MIME"application/xml"())

        if isempty(tags["TagSet"])
            return SSDict()
        end

        tags = tags["TagSet"]
        tags = isa(tags["Tag"], Vector) ? tags["Tag"] : [tags["Tag"]]

        return SSDict(x["Key"] => x["Value"] for x in tags)
    catch e
        @ignore if ecode(e) == "NoSuchTagSet"
            return SSDict()
        end
    end
end

s3_get_tags(a...; b...) = s3_get_tags(global_aws_config(), a...; b...)

"""
    s3_delete_tags([::AbstractAWSConfig], bucket, [path])

Delete the tags associated with a bucket or an existing object. When `path` is specified then
tag deletion is performed on the object, otherwise it is performed on the `bucket`.

See also [`s3_put_tags`](@ref) and [`s3_get_tags`](@ref).

# API Calls

- [`DeleteBucketTagging`](https://docs.aws.amazon.com/AmazonS3/latest/API/API_DeleteBucketTagging.html) (conditional): used when `path` is not specified (bucket tagging).
- [`DeleteObjectTagging`](https://docs.aws.amazon.com/AmazonS3/latest/API/API_DeleteObjectTagging.html) (conditional): used when `path` is specified (object tagging).

# Permissions

- [`s3:PutBucketTagging`](https://docs.aws.amazon.com/service-authorization/latest/reference/list_amazons3.html#amazons3-PutBucketTagging)
  (conditional): required for when `path` is not specified (bucket tagging).
- [`s3:DeleteObjectTagging`](https://docs.aws.amazon.com/service-authorization/latest/reference/list_amazons3.html#amazons3-DeleteObjectTagging)
  (conditional): required when `path` is specified (object tagging).
"""
function s3_delete_tags(aws::AbstractAWSConfig, bucket, path=""; kwargs...)
    r = if isempty(path)
        S3.delete_bucket_tagging(bucket; aws_config=aws, kwargs...)
    else
        S3.delete_object_tagging(bucket, path; aws_config=aws, kwargs...)
    end
    return parse(r)
end

s3_delete_tags(a...; b...) = s3_delete_tags(global_aws_config(), a...; b...)

"""
    s3_delete_bucket([::AbstractAWSConfig], "bucket"; kwargs...)

Deletes an empty bucket. All objects in the bucket must be deleted before a bucket can be
deleted.

See also [`AWSS3.s3_nuke_bucket`](@ref).

# API Calls

- [`DeleteBucket`](https://docs.aws.amazon.com/AmazonS3/latest/API/API_DeleteBucket.html)

# Permissions

- [`s3:DeleteBucket`](https://docs.aws.amazon.com/service-authorization/latest/reference/list_amazons3.html#amazons3-DeleteBucket)
"""
function s3_delete_bucket(aws::AbstractAWSConfig, bucket; kwargs...)
    return parse(S3.delete_bucket(bucket; aws_config=aws, kwargs...))
end
s3_delete_bucket(a; b...) = s3_delete_bucket(global_aws_config(), a; b...)

"""
    s3_list_buckets([::AbstractAWSConfig]; kwargs...)

Return a list of all of the buckets owned by the authenticated sender of the request.

# API Calls

- [`ListBuckets`](https://docs.aws.amazon.com/AmazonS3/latest/API/API_ListBuckets.html)

# Permissions

- [`s3:ListAllMyBuckets`](https://docs.aws.amazon.com/service-authorization/latest/reference/list_amazons3.html#amazons3-ListAllMyBuckets)
"""
function s3_list_buckets(aws::AbstractAWSConfig=global_aws_config(); kwargs...)
    r = S3.list_buckets(; aws_config=aws, kwargs...)
    buckets = parse(r)["Buckets"]

    isempty(buckets) && return []

    buckets = buckets["Bucket"]
    return [b["Name"] for b in (isa(buckets, Vector) ? buckets : [buckets])]
end

"""
    s3_list_objects([::AbstractAWSConfig], bucket, [path_prefix]; delimiter="/", max_items=1000, kwargs...)

[List Objects](http://docs.aws.amazon.com/AmazonS3/latest/API/RESTBucketGET.html)
in `bucket` with optional `path_prefix`.

Returns an iterator of `Dict`s with keys `Key`, `LastModified`, `ETag`, `Size`,
`Owner`, `StorageClass`.
"""
function s3_list_objects(
    aws::AbstractAWSConfig,
    bucket,
    path_prefix="";
    delimiter="/",
    start_after="",
    max_items=nothing,
    kwargs...,
)
    return Channel(; ctype=LittleDict, csize=128) do chnl
        more = true
        num_objects = 0
        token = ""

        while more
            q = Dict{String,String}("prefix" => path_prefix)

            for (name, v) in [
                ("delimiter", delimiter),
                ("start-after", start_after),
                ("continuation-token", token),
            ]
                isempty(v) || (q[name] = v)
            end

            if max_items !== nothing
                # Note: AWS seems to only return up to 1000 items
                q["max-keys"] = string(max_items - num_objects)
            end

            @repeat 4 try
                # Request objects
                r = parse(S3.list_objects_v2(bucket, q; aws_config=aws, kwargs...))

                token = get(r, "NextContinuationToken", "")
                isempty(token) && (more = false)
                if haskey(r, "Contents")
                    l = isa(r["Contents"], Vector) ? r["Contents"] : [r["Contents"]]
                    for object in l
                        put!(chnl, object)
                        num_objects += 1
                    end
                end
            catch e
                #! format: off
                @delay_retry if ecode(e) in ["NoSuchBucket"] end
                #! format: on
            end
        end
    end
end
s3_list_objects(a...; kw...) = s3_list_objects(global_aws_config(), a...; kw...)

"""
    s3_directory_stat([::AbstractAWSConfig], bucket, path)

Determine the properties of an S3 "directory", size and time of last modification, that cannot be determined
directly with the standard AWS API.  This returns a tuple `(s, tmlast)` where `s` is the size in bytes, and
`tmlast` is the time of the latest modification to a file within that directory.
"""
function s3_directory_stat(
    aws::AbstractAWSConfig, bucket::AbstractString, path::AbstractString
)
    s = 0  # total size in bytes
    tmlast = typemin(DateTime)
    # setting delimiter is needed to get all objects within path,
    # additionally, we have to make sure the path ends with "/" or it will pick up extra stuff
    endswith(path, "/") || (path = path * "/")
    for obj in s3_list_objects(aws, bucket, path; delimiter="")
        s += parse(Int, get(obj, "Size", "0"))
        t = get(obj, "LastModified", nothing)
        t = t ≡ nothing ? tmlast : DateTime(t[1:(end - 4)])
        tmlast = max(tmlast, t)
    end
    return s, tmlast
end
s3_directory_stat(a...) = s3_directory_stat(global_aws_config(), a...)

"""
    s3_list_keys([::AbstractAWSConfig], bucket, [path_prefix]; kwargs...)

Like [`s3_list_objects`](@ref) but returns object keys as `Vector{String}`.
"""
function s3_list_keys(aws::AbstractAWSConfig, bucket, path_prefix=""; kwargs...)
    return (o["Key"] for o in s3_list_objects(aws, bucket, path_prefix; kwargs...))
end

s3_list_keys(a...; b...) = s3_list_keys(global_aws_config(), a...; b...)

"""
    s3_list_versions([::AbstractAWSConfig], bucket, [path_prefix]; kwargs...)

List metadata about all versions of the objects in the `bucket` matching the
optional `path_prefix`.

# API Calls

- [`ListObjectVersions`](https://docs.aws.amazon.com/AmazonS3/latest/API/API_ListObjectVersions.html)

# Permissions

- [`s3:ListBucketVersions`](https://docs.aws.amazon.com/service-authorization/latest/reference/list_amazons3.html#amazons3-ListBucketVersions)
"""
function s3_list_versions(aws::AbstractAWSConfig, bucket, path_prefix=""; kwargs...)
    more = true
    versions = []
    marker = ""

    while more
        query = Dict{String,Any}("prefix" => path_prefix)

        if !isempty(marker)
            query["key-marker"] = marker
        end

        r = S3.list_object_versions(bucket, query; aws_config=aws, kwargs...)
        r = parse_xml(String(r))

        more = r["IsTruncated"] == "true"

        for e in eachelement(EzXML.root(r.x))
            if nodename(e) in ["Version", "DeleteMarker"]
                version = xml_dict(e)
                version["state"] = nodename(e)
                push!(versions, version)
                marker = version["Key"]
            end
        end
    end

    return versions
end

s3_list_versions(a...; b...) = s3_list_versions(global_aws_config(), a...; b...)

"""
    s3_purge_versions([::AbstractAWSConfig], bucket, [path_prefix [, pattern]]; kwargs...)

Removes all versions of an object except for the latest version. When `path_prefix` is
provided then only objects whose key starts with `path_prefix` will be purged. Use of
`pattern` further restricts which objects are purged by only purging object keys containing
the `pattern` (i.e string literal or regex). When both `path_prefix` and `pattern` are not'
specified then all objects in the bucket will be purged.

# API Calls

- [`ListObjectVersions`](https://docs.aws.amazon.com/AmazonS3/latest/API/API_ListObjectVersions.html)
- [`DeleteObject`](https://docs.aws.amazon.com/AmazonS3/latest/API/API_DeleteObject.html)

# Permissions

- [`s3:ListBucketVersions`](https://docs.aws.amazon.com/service-authorization/latest/reference/list_amazons3.html#amazons3-ListBucketVersions)
- [`s3:DeleteObjectVersion`](https://docs.aws.amazon.com/service-authorization/latest/reference/list_amazons3.html#amazons3-DeleteObjectVersion)
"""
function s3_purge_versions(
    aws::AbstractAWSConfig, bucket, path_prefix="", pattern=""; kwargs...
)
    for v in s3_list_versions(aws, bucket, path_prefix; kwargs...)
        if pattern == "" || occursin(pattern, v["Key"])
            if v["IsLatest"] != "true"
                S3.delete_object(
                    bucket,
                    v["Key"],
                    Dict("versionId" => v["VersionId"]);
                    aws_config=aws,
                    kwargs...,
                )
            end
        end
    end
end

s3_purge_versions(a...; b...) = s3_purge_versions(global_aws_config(), a...; b...)

"""
    s3_put([::AbstractAWSConfig], bucket, path, data, data_type="", encoding="";
           acl::AbstractString="", metadata::SSDict=SSDict(), tags::AbstractDict=SSDict(),
           parse_response::Bool=true, kwargs...)

[PUT Object](http://docs.aws.amazon.com/AmazonS3/latest/API/RESTObjectPUT.html)
`data` at `path` in `bucket`.

# Optional Arguments
- `data_type=`; `Content-Type` header.
- `encoding=`; `Content-Encoding` header.
- `acl=`; `x-amz-acl` header for setting access permissions with canned config.
    See [here](https://docs.aws.amazon.com/AmazonS3/latest/dev/acl-overview.html#canned-acl).
- `metadata::Dict=`; `x-amz-meta-` headers.
- `tags::Dict=`; `x-amz-tagging-` headers
                 (see also [`s3_put_tags`](@ref) and [`s3_get_tags`](@ref)).
- `parse_response::Bool=`; when `false`, return raw `AWS.Response`
- `kwargs`; additional kwargs passed through into `S3.put_object`
"""
function s3_put(
    aws::AbstractAWSConfig,
    bucket,
    path,
    data::Union{String,Vector{UInt8}},
    data_type="",
    encoding="";
    acl::AbstractString="",
    metadata::SSDict=SSDict(),
    tags::AbstractDict=SSDict(),
    parse_response::Bool=true,
    kwargs...,
)
    headers = Dict{String,Any}(["x-amz-meta-$k" => v for (k, v) in metadata])

    if isempty(data_type)
        data_type = "application/octet-stream"
        ext = splitext(path)[2]
        for (e, t) in [
            (".html", "text/html"),
            (".js", "application/javascript"),
            (".pdf", "application/pdf"),
            (".csv", "text/csv"),
            (".txt", "text/plain"),
            (".log", "text/plain"),
            (".dat", "application/octet-stream"),
            (".gz", "application/octet-stream"),
            (".bz2", "application/octet-stream"),
        ]
            if ext == e
                data_type = t
                break
            end
        end
    end

    headers["Content-Type"] = data_type

    if !isempty(tags)
        headers["x-amz-tagging"] = URIs.escapeuri(tags)
    end

    if !isempty(acl)
        headers["x-amz-acl"] = acl
    end

    if !isempty(encoding)
        headers["Content-Encoding"] = encoding
    end

    args = Dict("body" => data, "headers" => headers)

    response = S3.put_object(bucket, path, args; aws_config=aws, kwargs...)
    return parse_response ? parse(response) : response
end

s3_put(a...; b...) = s3_put(global_aws_config(), a...; b...)

function s3_begin_multipart_upload(
    aws::AbstractAWSConfig,
    bucket,
    path,
    args=Dict{String,Any}();
    kwargs...,
    # format trick: using this comment to force use of multiple lines
)
    r = S3.create_multipart_upload(bucket, path, args; aws_config=aws, kwargs...)
    return parse(r, MIME"application/xml"())
end

function s3_upload_part(
    aws::AbstractAWSConfig,
    upload,
    part_number,
    part_data;
    args=Dict{String,Any}(),
    kwargs...,
)
    args["body"] = part_data

    response = S3.upload_part(
        upload["Bucket"],
        upload["Key"],
        part_number,
        upload["UploadId"],
        args;
        aws_config=aws,
        kwargs...,
    )

    return get_robust_case(Dict(response.headers), "ETag")
end

function s3_complete_multipart_upload(
    aws::AbstractAWSConfig,
    upload,
    parts::Vector{String},
    args=Dict{String,Any}();
    parse_response::Bool=true,
    kwargs...,
)
    doc = XMLDocument()
    rootnode = setroot!(doc, ElementNode("CompleteMultipartUpload"))

    for (i, etag) in enumerate(parts)
        part = addelement!(rootnode, "Part")
        addelement!(part, "PartNumber", string(i))
        addelement!(part, "ETag", etag)
    end

    args["body"] = string(doc)

    response = S3.complete_multipart_upload(
        upload["Bucket"], upload["Key"], upload["UploadId"], args; aws_config=aws, kwargs...
    )

    return parse_response ? parse(response) : response
end

"""
    s3_multipart_upload(aws::AbstractAWSConfig, bucket, path, io::IO, part_size_mb=50;
                        parse_response::Bool=true, kwargs...)

Upload `data` at `path` in `bucket` using a [multipart upload](https://docs.aws.amazon.com/AmazonS3/latest/userguide/mpuoverview.html)

# Optional Arguments
- `part_size_mb`: maximum size per uploaded part, in bytes.
- `parse_response`: when `false`, return raw `AWS.Response`
- `kwargs`: additional kwargs passed through into `s3_upload_part` and `s3_complete_multipart_upload`

# API Calls

- [`CreateMultipartUpload`](https://docs.aws.amazon.com/AmazonS3/latest/API/API_CreateMultipartUpload.html)
- [`UploadPart`](https://docs.aws.amazon.com/AmazonS3/latest/API/API_UploadPart.html)
- [`CompleteMultipartUpload`](https://docs.aws.amazon.com/AmazonS3/latest/API/API_CompleteMultipartUpload.html)
"""
function s3_multipart_upload(
    aws::AbstractAWSConfig,
    bucket,
    path,
    io::IO,
    part_size_mb=50;
    parse_response::Bool=true,
    kwargs...,
)
    part_size = part_size_mb * 1024 * 1024

    upload = s3_begin_multipart_upload(aws, bucket, path)
    tags = Vector{String}()
    buf = Vector{UInt8}(undef, part_size)

    i = 0
    while (n = readbytes!(io, buf, part_size)) > 0
        if n < part_size
            resize!(buf, n)
        end

        push!(tags, s3_upload_part(aws, upload, (i += 1), buf; kwargs...))
    end

    return s3_complete_multipart_upload(aws, upload, tags; parse_response, kwargs...)
end

using MbedTLS

function _s3_sign_url_v2(
    aws::AbstractAWSConfig,
    bucket,
    path,
    seconds=3600;
    verb="GET",
    content_type="application/octet-stream",
    protocol="http",
)
    path = URIs.escapepath(path)

    expires = round(Int, Dates.datetime2unix(now(Dates.UTC)) + seconds)

    query = SSDict(
        "AWSAccessKeyId" => aws.credentials.access_key_id,
        "x-amz-security-token" => aws.credentials.token,
        "Expires" => string(expires),
        "response-content-disposition" => "attachment",
    )

    if verb != "PUT"
        content_type = ""
    end

    to_sign =
        "$verb\n\n$content_type\n$(query["Expires"])\n" *
        "x-amz-security-token:$(query["x-amz-security-token"])\n" *
        "/$bucket/$path?" *
        "response-content-disposition=attachment"

    key = aws.credentials.secret_key
    query["Signature"] = strip(base64encode(digest(MD_SHA1, to_sign, key)))

    endpoint = string(protocol, "://", bucket, ".s3.", aws.region, ".amazonaws.com")
    return "$endpoint/$path?$(URIs.escapeuri(query))"
end

function _s3_sign_url_v4(
    aws::AbstractAWSConfig,
    bucket,
    path,
    seconds=3600;
    verb="GET",
    content_type="application/octet-stream",
    protocol="http",
)
    path = URIs.escapepath("/$bucket/$path")

    now_datetime = now(Dates.UTC)
    datetime_stamp = Dates.format(now_datetime, "YYYYmmddTHHMMSS\\Z")
    date_stamp = Dates.format(now_datetime, "YYYYmmdd")

    service = "s3"
    scheme = "AWS4"
    algorithm = "HMAC-SHA256"
    terminator = "aws4_request"

    scope = "$date_stamp/$(aws.region)/$service/$terminator"
    host = if aws.region == "us-east-1"
        "s3.amazonaws.com"
    else
        "s3-$(aws.region).amazonaws.com"
    end

    headers = OrderedDict{String,String}("Host" => host)
    sort!(headers; by=name -> lowercase(name))
    canonical_header_names = join(map(name -> lowercase(name), collect(keys(headers))), ";")

    query = OrderedDict{String,String}(
        "X-Amz-Expires" => string(seconds),
        "X-Amz-Algorithm" => "$scheme-$algorithm",
        "X-Amz-Credential" => "$(aws.credentials.access_key_id)/$scope",
        "X-Amz-Date" => datetime_stamp,
        "X-Amz-Security-Token" => aws.credentials.token,
        "X-Amz-SignedHeaders" => canonical_header_names,
    )

    if !isempty(aws.credentials.token)
        query["X-Amz-Security-Token"] = aws.credentials.token
    end

    sort!(query; by=name -> lowercase(name))

    canonical_headers = join(
        map(
            header -> "$(lowercase(header.first)):$(lowercase(header.second))\n",
            collect(headers),
        ),
    )

    canonical_request = string(
        "$verb\n",
        "$path\n",
        "$(URIs.escapeuri(query))\n",
        "$canonical_headers\n",
        "$canonical_header_names\n",
        "UNSIGNED-PAYLOAD",
    )

    string_to_sign = string(
        "$scheme-$algorithm\n",
        "$datetime_stamp\n",
        "$scope\n",
        bytes2hex(digest(MD_SHA256, canonical_request)),
    )

    key_secret = string(scheme, aws.credentials.secret_key)
    key_date = digest(MD_SHA256, date_stamp, key_secret)
    key_region = digest(MD_SHA256, aws.region, key_date)
    key_service = digest(MD_SHA256, service, key_region)
    key_signing = digest(MD_SHA256, terminator, key_service)
    signature = digest(MD_SHA256, string_to_sign, key_signing)

    query["X-Amz-Signature"] = bytes2hex(signature)

    return string(protocol, "://", host, path, "?", URIs.escapeuri(query))
end

"""
    s3_sign_url([::AbstractAWSConfig], bucket, path, [seconds=3600];
                [verb="GET"], [content_type="application/octet-stream"],
                [protocol="http"], [signature_version="v4"])

Create a [pre-signed url](http://docs.aws.amazon.com/AmazonS3/latest/dev/ShareObjectPreSignedURL.html) for `bucket` and `path` (expires after for `seconds`).

To create an upload URL use `verb="PUT"` and set `content_type` to match
the type used in the `Content-Type` header of the PUT request.

For compatibility, the signature version 2 signing process can be used by setting
`signature_version="v2"` but it is [recommended](https://docs.aws.amazon.com/general/latest/gr/signature-version-2.html) that the default version 4 is used.

```
url = s3_sign_url("my_bucket", "my_file.txt"; verb="PUT")
Requests.put(URI(url), "Hello!")
```
```
url = s3_sign_url("my_bucket", "my_file.txt";
                  verb="PUT", content_type="text/plain")

Requests.put(URI(url), "Hello!";
             headers=Dict("Content-Type" => "text/plain"))
```

# Permissions

- [`s3:GetObject`](https://docs.aws.amazon.com/service-authorization/latest/reference/list_amazons3.html#amazons3-GetObject)
  (conditional): required permission when `verb="GET"`.
- [`s3:PutObject`](https://docs.aws.amazon.com/service-authorization/latest/reference/list_amazons3.html#amazons3-PutObject)
  (conditional): required permission when `verb="PUT"`.
"""
function s3_sign_url(
    aws::AbstractAWSConfig,
    bucket,
    path,
    seconds=3600;
    verb="GET",
    content_type="application/octet-stream",
    protocol="http",
    signature_version="v4",
)
    if signature_version == "v2"
        _s3_sign_url_v2(aws, bucket, path, seconds; verb, content_type, protocol)
    elseif signature_version == "v4"
        _s3_sign_url_v4(aws, bucket, path, seconds; verb, content_type, protocol)
    else
        throw(ArgumentError("Unknown signature version $signature_version"))
    end
end

s3_sign_url(a...; b...) = s3_sign_url(global_aws_config(), a...; b...)

"""
    s3_nuke_bucket([::AbstractAWSConfig], bucket_name)

Deletes a bucket including all of the object versions in that bucket. Users should not call
this function unless they are certain they want to permanently delete all of the data that
resides within this bucket.

The `s3_nuke_bucket` is purposefully *not* exported as a safe guard against accidental
usage.

!!! warning

    Permanent data loss will occur when using this function. Do not use this function unless
    you understand the risks. By using this function you accept all responsibility around
    any repercussions with the loss of this data.

# API Calls

- [`ListObjectVersions`](https://docs.aws.amazon.com/AmazonS3/latest/API/API_ListObjectVersions.html)
- [`DeleteObject`](https://docs.aws.amazon.com/AmazonS3/latest/API/API_DeleteObject.html)
- [`DeleteBucket`](https://docs.aws.amazon.com/AmazonS3/latest/API/API_DeleteBucket.html)

# Permissions

- [`s3:ListBucketVersions`](https://docs.aws.amazon.com/service-authorization/latest/reference/list_amazons3.html#amazons3-ListBucketVersions)
- [`s3:DeleteObjectVersion`](https://docs.aws.amazon.com/service-authorization/latest/reference/list_amazons3.html#amazons3-DeleteObjectVersion):
  required even on buckets that do not have versioning enabled.
- [`s3:DeleteBucket`](https://docs.aws.amazon.com/service-authorization/latest/reference/list_amazons3.html#amazons3-DeleteBucket)
"""
function s3_nuke_bucket(aws::AbstractAWSConfig, bucket_name)
    for v in s3_list_versions(aws, bucket_name)
        s3_delete(aws, bucket_name, v["Key"]; version=v["VersionId"])
    end

    return s3_delete_bucket(aws, bucket_name)
end

include("s3path.jl")

end #module AWSS3

#==============================================================================#
# End of file.
#==============================================================================#

```@meta
CurrentModule = AWSS3
```

## S3 Interaction
```@docs
s3_arn
s3_get
s3_get_file
s3_get_meta
s3_exists
s3_delete
s3_copy
s3_create_bucket
s3_put_cors
s3_enable_versioning
s3_put_tags
s3_get_tags
s3_delete_tags
s3_delete_bucket
s3_list_buckets
s3_list_objects
s3_list_keys
s3_purge_versions
s3_put
s3_sign_url
s3_nuke_bucket
```

## `S3Path`
Note that `S3Path` implements the `AbstractPath` interface, some the FilePathsBase documentation for
the interface [here](https://rofinn.github.io/FilePathsBase.jl/stable/api/).
```@docs
S3Path
stat
mkdir
read
get_config
```


## Internal
```@docs
_s3_exists_dir
s3_exists_versioned
s3_exists_unversioned
```

```@meta
CurrentModule = AWSS3
```

# AWSS3.jl

AWSS3.jl is a Julia package for interacting with key-value data storage services [AWS S3](https://aws.amazon.com/s3/)
and [min.io](https://min.io/).  It operates through HTTP calls to a REST API service.  It is based
on the package [AWS.jl](https://github.com/JuliaCloud/AWS.jl) which provides a direct wrapper to
low-level API calls but provides a great deal of additional convenient functionality.


## Quick Start
```julia
using AWSS3
using AWS # for `global_aws_config`

aws = global_aws_config(; region="us-east-2") # pass keyword arguments to change defaults

s3_create_bucket(aws, "my.bucket")
s3_enable_versioning(aws, "my.bucket")

s3_put(aws, "my.bucket", "key", "Hello!")
println(s3_get(aws, "my.bucket", "key"))  # prints "Hello!"
println(s3_get(aws, "my.bucket", "key", byte_range=1:2))  # prints only "He"
```

## `S3Path`
This package provides the `S3Path` object which implements the
[FilePathsBase](https://github.com/rofinn/FilePathsBase.jl) interface, thus providing a
filesystem-like abstraction for interacting with S3.  In particular, this allows for interacting
with S3 using the [filesystem interface](https://docs.julialang.org/en/v1/base/file/) provided by
Julia's `Base`.  This makes it possible to (mostly) write code which works the same way for S3 as it
does for the local filesystem.

```julia
julia> using AWSS3, AWS, FilePathsBase;

# global_aws_config() is also the default if no `config` argument is passed
julia> p = S3Path("s3://bucket-name/dir1/", config=global_aws_config());

julia> readdir(p)
1-element Vector{SubString{String}}:
 "demo.txt"

julia> file = joinpath(p, "demo.txt")
p"s3://bucket-name/dir1/demo.txt"

julia> stat(file)
Status(
  device = 0,
  inode = 0,
  mode = -rw-rw-rw-,
  nlink = 0,
  uid = 1000 (username),
  gid = 1000 (username),
  rdev = 0,
  size = 34 (34.0),
  blksize = 4096 (4.0K),
  blocks = 1,
  mtime = 2021-01-30T18:53:02,
  ctime = 2021-01-30T18:53:02,
)

julia> String(read(file))  # fetch the file into memory
"this is a file for testing S3Path\n"

julia> String(read(file, byte_range=1:4))  # fetch a specific byte range of the file
"this"

julia> rm(file)  # delete the file
UInt8[]
```

!!! warning

    S3 is a pure [key-value store](https://en.wikipedia.org/wiki/Key%E2%80%93value_database),
    **NOT** a filesystem.  Therefore, though S3 has, over time, gained features which oftne mimic a
    filesystem interface, in some cases it can behave very differently.  In particular "empty
    directories" are, in actuality, 0-byte files and can have some unexpected behavior, e.g. there
    is no `stat(dir)` like in a true filesystem.

## Min.io
Min.io is fully compatible with the S3 API and therefore this package can be used to interact with
it.  To use Min.io requires a dedicated AWS configuration object, see the
[Minio.jl](https://gitlab.com/ExpandingMan/Minio.jl) package.  This package also contains some
convenience functions for easily setting up a server for experimentation and testing with the
min.io/S3 interface.
